/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

//////////////////////////////////////////
//
// Graphics .H file for .CKD
// IGRAB-ed on Fri Nov 19 16:58:34 1993
// Updated for ID Engine from Catacomb 3-D
//
//////////////////////////////////////////

typedef enum {
		H_MENUPIC=6,
		H_HANDPIC=45,
		H_TOPWINDOWPIC=80,	
		H_LEFTWINDOWPIC=81,
		H_RIGHTWINDOWPIC=82,
		H_BOTTOMINFOPIC=83,
		H_BOTTOMWINDOWPIC=84,



		// Lump Start
		CP_MAINMENUPIC=88,
		CP_NEWGAMEMENUPIC=89,
		CP_LOADMENUPIC=90,
		CP_SAVEMENUPIC=91,
		CP_CONFIGMENUPIC=92,
		CP_SOUNDMENUPIC=93,
		CP_MUSICMENUPIC=94,
		CP_KEYBOARDMENUPIC=95,
		CP_KEYMOVEMENTPIC=96,
		CP_KEYBUTTONPIC=97,
		CP_JOYSTICKMENUPIC=98,
		CP_OPTIONSMENUPIC=99,
		CP_PADDLEWARPIC=100,
		CP_QUITPIC=101,
		CP_JOYSTICKPIC=102,
		CP_MENUSCREENPIC=103,

		I_CREDITS1=104,
		I_CREDITS2=105,
		I_CREDITS3=106,
		I_CREDITS4=107,
		I_TITLEPIC=109,

		CP_MENUMASKPICM=131,
		MPIC_STATUSTOP=132,
		MPIC_STATUSLEFT=133,

		PADDLESPR=134,
		BALLSPR=135,
		BALL1PIXELTOTHERIGHTSPR=136,

		DEMOSIGNSPR=139,

		KEENSTANDRSPR=140,
		KEENRUNR1SPR=141,
		KEENRUNR2SPR=142,
		KEENRUNR3SPR=143,
		KEENRUNR4SPR=144,
		KEENJUMPR1SPR=145,
		KEENJUMPR2SPR=146,
		KEENJUMPR3SPR=147,
		KEENSTANDLSPR=148,
		KEENRUNL1SPR=149,
		KEENRUNL2SPR=150,
		KEENRUNL3SPR=151,
		KEENRUNL4SPR=152,
		KEENJUMPL1SPR=153,
		KEENJUMPL2SPR=154,
		KEENJUMPL3SPR=155,
		KEENLOOKUPSPR=156,
		KEENANGRY1SPR=157,
		KEENANGRY2SPR=158,
		KEENSHRUGSPR=159,
		KEENBOOK1SPR=160,
		KEENBOOK2SPR=161,
		KEENBOOK3SPR=162,
	       	KEENBOOK4SPR=163,
	       	KEENBOOKREADSPR=164,
	       	KEENBOOKFLIP1SPR=165,
	       	KEENBOOKFLIP2SPR=166,
	       	KEENPUTBOOKAWAY1SPR=167,
		KEENPUTBOOKAWAY2SPR=168,
		KEENLOOKATWATCHSPR=169,
		KEENLOOKDOWN1SPR=170,
		KEENLOOKDOWN2SPR=171,
		KEENDIE1SPR=172,
		KEENDIE2SPR=173,
		STUNNEDSTARS1SPR=174,
		STUNNEDSTARS2SPR=175,
		STUNNEDSTARS3SPR=176,
		KEENSHOOTLEFTSPR=177,
		KEENJUMPSHOOTLEFTSPR=178,
		KEENJUMPSHOOTDOWNSPR=179,
		KEENJUMPSHOOTUPSPR=180,
		KEENSHOOTUPSPR=181,
		KEENSHOOTRIGHTSPR=182,
		KEENJUMPSHOOTRIGHTSPR=183,
		STUNNER1SPR=184,
		STUNNER2SPR=185,
		STUNNER3SPR=186,
		STUNNER4SPR=187,
		STUNNERDIE1SPR=188,
		STUNNERDIE2SPR=189,
		KEENPOLECLIMBR1SPR=190,
		KEENPOLECLIMBR2SPR=191,
		KEENPOLECLIMBR3SPR=192,
		KEENPOLESLIDE1SPR=193,
		KEENPOLESLIDE2SPR=194,
		KEENPOLESLIDE3SPR=195,
		KEENPOLESLIDE4SPR=196,
		KEENPOLECLIMBL1SPR=197,
		KEENPOLECLIMBL2SPR=198,
		KEENPOLECLIMBL3SPR=199,
		KEENPOLESHOOTUPLSPR=200,
		KEENPOLESHOOTUPRSPR=201,
		KEENPOLESHOOTDOWNLSPR=202,
		KEENPOLESHOOTDOWNRSPR=203,
		
		KEENPOLESHOOTLEFTSPR=204,
		KEENPOLESHOOTRIGHTSPR=205,
		KEENWALKAWAY1SPR=206,
		KEENWALKAWAY2SPR=207,
		KEENWALKAWAY3SPR=208,
		KEENWALKAWAY4SPR=209,
		KEENWALKAWAY5SPR=210,
		KEENHANGLSPR=211,
		KEENHANGRSPR=212,
		KEENCLIMBL1SPR=213,
		KEENCLIMBL2SPR=214,
		KEENCLIMBL3SPR=215,
		KEENCLIMBL4SPR=216,
		KEENCLIMBR1SPR=217,
		KEENCLIMBR2SPR=218,
		KEENCLIMBR3SPR=219,
		KEENCLIMBR4SPR=220,
		KEENPOGORSPR=221,
		KEENPOGOBOUNCERSPR=222,
		KEENPOGOLSPR=223,
		KEENPOGOBOUNCELSPR=224,
		
		VITALINBURST1SPR=225,
		VITALINBURST2SPR=226,
		VITALINBURST3SPR=227,
		VITALIN1UPSHADOWSPR=228,
		POINTS100SHADOWSPR=229,
		POINTS200SHADOWSPR=230,
		POINTS500SHADOWSPR=231,
		POINTS1000SHADOWSPR=232,
		POINTS2000SHADOWSPR=233,
		POINTS5000SHADOWSPR=234,
		POINTS1UPSHADOWSPR=235,
		STUNNERSHADOWSPR=236,
		POINTS100ITEM1SPR=237,
		POINTS100ITEM2SPR=238,
		POINTS200ITEM1SPR=239,
		POINTS200ITEM2SPR=240,
		POINTS500ITEM1SPR=241,
		POINTS500ITEM2SPR=242,
		POINTS1000ITEM1SPR=243,
		POINTS1000ITEM2SPR=244,
		POINTS2000ITEM1SPR=245,
		POINTS2000ITEM2SPR=246,
		POINTS5000ITEM1SPR=247,
		POINTS5000ITEM2SPR=248,
		ITEM1UP1SPR=249,	
		ITEM1UP2SPR=250,
		ITEM1UPSHADOW=251,
		REDGEM1SPR=252,
		REDGEM2SPR=253,
		YELLOWGEM1SPR=254,
		YELLOWGEM2SPR=255,
		BLUEGEM1SPR=256,
		BLUEGEM2SPR=257,
		GREENGEM1SPR=258,
		GREENGEM2SPR=259,
		GEMSHADOWSPR=260,
		ITEMSTUNNER1SPR=261,
		ITEMSTUNNER2SPR=262, 

		SCOREBOXSPR = 263,

		WORLDKEENL1SPR=264,
		WORLDKEENL2SPR=265,
		WORLDKEENL3SPR=266,
		WORLDKEENR1SPR=267,
		WORLDKEENR2SPR=268,
		WORLDKEENR3SPR=269,
		WORLDKEENU1SPR=270,
		WORLDKEENU2SPR=271,
		WORLDKEENU3SPR=272,
		WORLDKEEND1SPR=273,
		WORLDKEEND2SPR=274,
		WORLDKEEND3SPR=275,
		WORLDKEENDR1SPR=276,
		WORLDKEENDR2SPR=277,
		WORLDKEENDR3SPR=278,
		WORLDKEENDL1SPR=279,
		WORLDKEENDL2SPR=280,
		WORLDKEENDL3SPR=281,
		WORLDKEENUL1SPR=282,
		WORLDKEENUL2SPR=283,
		WORLDKEENUL3SPR=284,
		WORLDKEENUR1SPR=285,
		WORLDKEENUR2SPR=286,
		WORLDKEENUR3SPR=287,
		WORLDKEENWAVE1SPR=288,
		WORLDKEENWAVE2SPR=289,


		KEENSAUCER1SPR=306,
		KEENSAUCER2SPR=307,
		FLAGFLIP1SPR=308,
		FLAGFLIP2SPR=309,
		FLAGFLIP3SPR=310,
		FLAGFLIP4SPR=311,
		FLAGFLIP5SPR=312,
		FLAGFLIP6SPR=313,
		FLAGFLIP7SPR=314,
		FLAGWAVE1SPR=315,
		FLAGWAVE2SPR=316,
		FLAGWAVE3SPR=317,
		FLAGWAVE4SPR=318,

		KEENVINES1SPR=319, 
		KEENVINES2SPR=320, 
		KEENVINES3SPR=321, 
		KEENVINES4SPR=322, 
		KEENVINES5SPR=323, 
		KEENVINES6SPR=324, 

		SPR_LARVACWALK1=325,
		SPR_LARVACWALK2=326,
		SPR_LARVACEXCR=327,
		SPR_LARVACDEAD=328,
		SPR_LARSLIME1=333,
		SPR_LARSLIME2=334,

		SPR_BEETLEIDLE1=335,
		SPR_BEETLEIDLE2=336,
		SPR_BEETLEJUMP1=337,
		SPR_BEETLEJUMP2=338,

		SPR_MAGMINE1=343,
		SPR_MAGMINE2=344,
		SPR_MAGMINE3=345,
		SPR_MAGMINE4=346,
		SPR_MAGMINEEXPL1=347,
		SPR_MAGMINEEXPL2=348,
		SPR_MAGMINEEXPL3=349,
		SPR_MAGMINEEXPL4=350,
		SPR_MAGMINEEXPL5=351,

		SMALLEXPLOSION1SPR=353,
		SMALLEXPLOSION2SPR=354,
		SMALLEXPLOSION3SPR=355,

		SPR_ATROXIANWALKL1=377,
		SPR_ATROXIANWALKL2=378,
		SPR_ATROXIANWALKL3=379,
		SPR_ATROXIANWALKL4=380,
		SPR_ATROXIANWALKR1=381,
		SPR_ATROXIANWALKR2=382,
		SPR_ATROXIANWALKR3=383,
		SPR_ATROXIANWALKR4=384,
		SPR_ATROXIANFLY1=385,
		SPR_ATROXIANFLY2=386,
		SPR_ATROXIANFLY3=387,
		SPR_ATROXIANFLY4=388,
		SPR_ATROXIANSTUNNED=389,

		SPR_ATROXIANDEAD=361,

		SPR_SPLIDERIDLE=398,
		SPR_SPLIDERWALKR1=399,
		SPR_SPLIDERWALKR2=400,
		SPR_SPLIDERWALKR3=401,
		SPR_SPLIDERWALKR4=402,
		SPR_SPLIDERWALKL1=403,
		SPR_SPLIDERWALKL2=404,
		SPR_SPLIDERWALKL3=405,
		SPR_SPLIDERWALKL4=406,
		SPR_SPLIDERSLIDER1=407,
		SPR_SPLIDERSLIDER2=408,
		SPR_SPLIDERSLIDER3=409,
		SPR_SPLIDERSLIDEL1=410,
		SPR_SPLIDERSLIDEL2=411,
		SPR_SPLIDERSLIDEL3=412,
		SPR_SPLIDERDEAD=413,

		SPR_FIREBALL1=450,
		SPR_FIREBALL2=451,
		SPR_FIREBALL3=452,

		SPR_LARVBATL1=453,
		SPR_LARVBATL2=454,
		SPR_LARVBATR1=455,
		SPR_LARVBATR2=456,
		//TODO: put this in a lump!
		SPR_LARVBATDIE1=356,
		SPR_LARVBATDIE2=357,
		SPR_LARVBATDIE3=358,
		SPR_LARVBATDIE4=359,

		SPR_ATROXITEJUMPR1=479,
		SPR_ATROXITEJUMPR2=480,
		SPR_ATROXITEJUMPR3=481,
		SPR_ATROXITEJUMPR4=482,
		SPR_ATROXITEJUMPL1=483,
		SPR_ATROXITEJUMPL2=484,
		SPR_ATROXITEJUMPL3=485,
		SPR_ATROXITEJUMPL4=486,
		SPR_ATROXITEATTACKR1=487,
		SPR_ATROXITEATTACKR2=488,
		SPR_ATROXITEATTACKR3=489,
		SPR_ATROXITEATTACKL1=490,
		SPR_ATROXITEATTACKL2=491,
		SPR_ATROXITEATTACKL3=492,
		SPR_ATROXITEDEAD=493,

		SPR_PLATFORM=494,
		SPR_PLATFIRED1=495,
		SPR_PLATFIRED2=496,
		SPR_PLATFIREL1=497,
		SPR_PLATFIREL2=498,
		SPR_PLATFIRER1=499,
		SPR_PLATFIRER2=500,

		SPR_DARTFROGSITL=501,
		SPR_DARTFROGJUMPL=502,
		SPR_DARTFROGSITR=503,
		SPR_DARTFROGJUMPR=504,
		SPR_DARTFROGIDLE=505,
		SPR_DARTFROGIDLE2=506,
		SPR_DARTFROGDEAD=507,

		SPR_AXOCLAWMOVE1=508,
		SPR_AXOCLAWMOVE2=509,
		SPR_AXOCLAWSHOOT1=510,
		SPR_AXOSHOTDIE1=511,
		SPR_AXOSHOTDIE2=512,
		SPR_AXOSHOT1=431,
		SPR_AXOSHOT2=432,
		SPR_AXOSHOT3=433,
		SPR_AXOSHOT4=434,

		AXOSISWALKL1SPR=435,
		AXOSISWALKL2SPR=436,
		AXOSISWALKR1SPR=437,
		AXOSISWALKR2SPR=438,

		SPR_AXOSISSTUN1=457,
		SPR_AXOSISSTUN2=458,
		SPR_AXOSISSTUN3=459,
		SPR_AXOSISSTUN4=460,
		SPR_AXOSISSTUNNED=461,
		SPR_AXOSISPREEN1=462,
		SPR_AXOSISPREEN2=463,
		SPR_AXOSISPREEN3=464,
		SPR_AXOSISPREEN4=465,
		SPR_AXOSISDEAD=466,

		SPR_KRILEGHOSTFLOAT1=290,
		SPR_KRILEGHOSTFLOAT2=291,
		SPR_KRILEGHOSTATTACK1=292,
		SPR_KRILEGHOSTATTACK2=293,
		SPR_KRILEGHOSTTELE1=294,
		SPR_KRILEGHOSTTELE2=295,
		SPR_KRILEGHOSTTELE3=296,
		SPR_KRILEGHOSTTELE4=297,

		SPR_HORNETWALKR1=467,
		SPR_HORNETWALKR2=468,
		SPR_HORNETWALKL1=469,
		SPR_HORNETWALKL2=470,
		SPR_HORNETDEAD=471,
		SPR_HORNETSLIDER1=472,
		SPR_HORNETSLIDER2=473,
		SPR_HORNETSLIDER3=474,
		SPR_HORNETSLIDEL1=475,
		SPR_HORNETSLIDEL2=476,
		SPR_HORNETSLIDEL3=477,


		SPR_MOXEL1=441,
		SPR_MOXELSHOOT1=442,
		SPR_MOXELSHOOT2=443,

		SPR_MOXELSHOT1=525,
		SPR_MOXELSHOT2=526,
		SPR_MOXELSHOT3=527,
		SPR_MOXELSHOT4=528,

		SPR_KRILEGUARDWALKL1=513,
		SPR_KRILEGUARDWALKL2=514,
		SPR_KRILEGUARDWALKL3=515,
		SPR_KRILEGUARDWALKL4=516,
		SPR_KRILEGUARDWALKR1=517,
		SPR_KRILEGUARDWALKR2=518,
		SPR_KRILEGUARDWALKR3=519,
		SPR_KRILEGUARDWALKR4=520,
		SPR_KRILEGUARDSHOOTL1=521,
		SPR_KRILEGUARDSHOOTL2=522,
		SPR_KRILEGUARDSHOOTR1=523,
		SPR_KRILEGUARDSHOOTR2=524,

		SPR_GUARDSHOT1=446,
		SPR_GUARDSHOT2=447,
		SPR_GUARDSHOT3=448,
		SPR_GUARDSHOT4=449,
		SPR_GUARDSHOTDIE1=352,
		SPR_GUARDSHOTDIE2=439,

		DARTSOUTH1SPR=390,
		DARTSOUTH2SPR=391,
		DARTNORTH1SPR=392,
		DARTNORTH2SPR=393,
		DARTEAST1SPR=394,
		DARTEAST2SPR=395,
		DARTWEST1SPR=396,
		DARTWEST2SPR=397,

		GENERATORIDLESPR=365,
		GENERATOREXPLODE1SPR=366,
		GENERATOREXPLODE2SPR=367,
		GENERATOREXPLODE3SPR=368,
		GENERATOREXPLODE4SPR=369,
		GENERATOREXPLODE5SPR=370,
		GENERATOREXPLODE6SPR=371,

		ATROXUSDETECTSPR=362,
		ELDER2SPR = 363,
		ELDER1SPR = 364,

		BRIDGESPR = 440,

		ITEM3UP1SPR = 340,
		ITEM3UP2SPR = 341,
		ITEM3UP3SPR = 342,


		CHECKPOINTSPR=298,
		CHECKPOINTSPIN1SPR=299,
		CHECKPOINTSPIN2SPR=300,
		CHECKPOINTSPIN3SPR=301,
		CHECKPOINTSPIN4SPR=302,
		CHECKPOINTSHADOWSPR=303,

		
		ABOMB1SPR=372,
		ABOMB2SPR=373,


		ATROXUSL1SPR=414,
		ATROXUSL2SPR=415,
		ATROXUSL3SPR=416,
		ATROXUSPAINSPR=417,
		ATROXUSDROPBOMBSPR=418,

		ABOMBSHOCKWAVEL1SPR=419,
		ABOMBSHOCKWAVEL2SPR=420,
		ABOMBSHOCKWAVER1SPR=421,
		ABOMBSHOCKWAVER2SPR=422,
		ABOMBFIRE1SPR=423,
		ABOMBFIRE2SPR=424,
		ABOMBFIREDIE1SPR=425,
		ABOMBFIREDIE2SPR=426,
		//unused

		ATROXUSR1SPR=428,
		ATROXUSR2SPR=429,
		ATROXUSR3SPR=430,
		
		ATROXUSDROPBOMB1SPR=444,
		ATROXUSDROPBOMB2SPR=445,

		ATROXUSDEBRIS1SPR=304,
		ATROXUSDEBRIS2SPR=305,

		I_INTROCOMMANDER=5124,
		I_INTROKEEN=5125,

		

		T_HELPMAIN=5127,
		T_HELPSTORY=5128,
		T_HELPCONTROLS=5129,
		T_HELPABOUT=5130,
		T_ENDDIALOGUE=5131,
		T_NORMALEND=5132,
		T_HELPORDER=5133,
		T_BWBKRILE=5134,
		T_KRILEELDER=5135,
		T_ATROXUS=5136,
		T_SECRETKRILE=5137,
		T_SECRETEND=5138,
		T_END2=5139,
		T_END3=5140,
		T_ATROXUSBOX1=5141,
		T_ATROXUSBOX2=5142,
		T_ATROXUSBOX3=5143,

		ANSI_ENDTEXT = 5123,




	     } graphicnums;

//
// Data LUMPs
//
#define CONTROLS_LUMP_START		88
#define CONTROLS_LUMP_END		103
#define KEEN_LUMP_START			140
#define KEEN_LUMP_END			263
#define WORLDKEEN_LUMP_START		264
#define WORLDKEEN_LUMP_END		289
#define PLATFORM_LUMP_START		494
#define PLATFORM_LUMP_END		500
#define LARVAC_LUMP_START		325
#define LARVAC_LUMP_END			334
#define BEETLE_LUMP_START		335
#define BEETLE_LUMP_END			338
#define MAGMINE_LUMP_START		343
#define MAGMINE_LUMP_END		351
#define FIREBALL_LUMP_START		450
#define FIREBALL_LUMP_END		452
#define DARTFROG_LUMP_START		501
#define DARTFROG_LUMP_END		507
#define SPLIDER_LUMP_START		398
#define SPLIDER_LUMP_END		413
#define LARVBAT_LUMP_START		453
#define LARVBAT_LUMP_END		456
#define ATROXIAN_LUMP_START		377
#define ATROXIAN_LUMP_END		389
#define ATROXITE_LUMP_START		479
#define ATROXITE_LUMP_END		493
#define AXOCLAW1_LUMP_START		508
#define AXOCLAW1_LUMP_END		512
#define AXOCLAW2_LUMP_START		431
#define AXOCLAW2_LUMP_END		434
#define AXOSIS_LUMP_START		457
#define AXOSIS_LUMP_END			466
#define HORNET_LUMP_START		467
#define HORNET_LUMP_END			477
#define MOXEL_LUMP_START		441
#define MOXEL_LUMP_END			443
#define MOXELSHOT_LUMP_START		525
#define MOXELSHOT_LUMP_END		528
#define KRILEGUARDIAN_LUMP_START	513
#define KRILEGUARDIAN_LUMP_END		524
#define KRILEGUARDIANSHOT_LUMP_START	446
#define KRILEGUARDIANSHOT_LUMP_END	449
#define KRILEGHOST_LUMP_START		290
#define KRILEGHOST_LUMP_END		297
#define MAPKEEN2_LUMP_START		306
#define MAPKEEN2_LUMP_END		318
#define DART_LUMP_START			390
#define DART_LUMP_END			397
#define SMALLEXPOSION_LUMP_START	353
#define SMALLEXPOSION_LUMP_END		355
#define MAGMINEEXPLOSION_LUMP_START	347
#define MAGMINEEXPLOSION_LUMP_END	351
#define GENERATOR_LUMP_START		365
#define GENERATOR_LUMP_END		371
#define ELDER_LUMP_START		364
#define ELDER_LUMP_END			364
#define BRIDGE_LUMP_START		440
#define BRIDGE_LUMP_END			440
#define CHECKPOINT_LUMP_START		298
#define CHECKPOINT_LUMP_END		303
#define KEENVINES_LUMP_START		319
#define KEENVINES_LUMP_END		324
#define AXOSIS2_LUMP_START		435
#define AXOSIS2_LUMP_END		438
#define ATROXUS_LUMP_START		414
#define ATROXUS_LUMP_END		430

#define PADDLE_LUMP_START		134
#define PADDLE_LUMP_END			138
//
// Amount of each data item
//
#define NUMCHUNKS    5150
#define NUMFONT      3
#define NUMFONTM     0
#define NUMPICS      135
#define NUMPICM      3
#define NUMSPRITES   397
#define NUMTILE8     104
#define NUMTILE8M    20
#define NUMTILE16    1386
#define NUMTILE16M   3204
#define NUMTILE32    0
#define NUMTILE32M   0
//
// File offsets for data items
//
#define STRUCTPIC    0
#define STRUCTPICM   1
#define STRUCTSPRITE 2

#define STARTFONT    3
#define STARTFONTM   6
#define STARTPICS    6
#define STARTPICM    131
#define STARTSPRITES 134
#define STARTTILE8   531
#define STARTTILE8M  532
#define STARTTILE16  533
#define STARTTILE16M 1919
#define STARTTILE32  5123
#define STARTTILE32M 5123
// Hack for Catacomb 3-D's ID_CA.C
#define STARTEXTERNS 5123
#define STARTDEMOS   5144 

//
// Thank you for using IGRAB!
//
