/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// KD_KEEN.C

#include "KD_DEF.H"
#pragma hdrstop

/*
=============================================================================

						 LOCAL CONSTANTS

=============================================================================
*/

/*
=============================================================================

						 GLOBAL VARIABLES

=============================================================================
*/


CK_action CK_ACT_keenStanding;
CK_action CK_ACT_keenRidePlatform;
CK_action CK_ACT_keenLookUp1;
CK_action CK_ACT_keenLookUp2;
CK_action CK_ACT_keenLookDown1;
CK_action CK_ACT_keenLookDown2;
CK_action CK_ACT_keenLookDown3;
CK_action CK_ACT_keenLookDown4;
CK_action CK_ACT_keenIdle;
CK_action CK_ACT_keenBored1;
CK_action CK_ACT_keenBored2;
CK_action CK_ACT_keenBored3;
CK_action CK_ACT_keenBored4;
CK_action CK_ACT_keenBored5;
CK_action CK_ACT_keenBored6;
CK_action CK_ACT_keenOpenBook1;
CK_action CK_ACT_keenOpenBook2;
CK_action CK_ACT_keenOpenBook3;
CK_action CK_ACT_keenOpenBook4;
CK_action CK_ACT_keenReadBook1;
CK_action CK_ACT_keenReadBook2;
CK_action CK_ACT_keenReadBook3;
CK_action CK_ACT_keenStowBook1;
CK_action CK_ACT_keenStowBook2;
CK_action CK_ACT_keenStowBook3;
CK_action CK_ACT_keenNot;
CK_action CK_ACT_keenDie0;
CK_action CK_ACT_keenDie1;
CK_action CK_ACT_keenRun1;
CK_action CK_ACT_keenRun2;
CK_action CK_ACT_keenRun3;
CK_action CK_ACT_keenRun4;
CK_action CK_ACT_keenShoot1;
CK_action CK_ACT_keenShoot2;
CK_action CK_ACT_keenShootUp1;
CK_action CK_ACT_keenShootUp2;
CK_action CK_ACT_keenJump1;
CK_action CK_ACT_keenJump2;
CK_action CK_ACT_keenFall1;
CK_action CK_ACT_keenFall2;
CK_action CK_ACT_keenJumpShoot1;
CK_action CK_ACT_keenJumpShoot2;
CK_action CK_ACT_keenJumpShoot3;
CK_action CK_ACT_keenJumpShootUp1;
CK_action CK_ACT_keenJumpShootUp2;
CK_action CK_ACT_keenJumpShootUp3;
CK_action CK_ACT_keenJumpShootDown1;
CK_action CK_ACT_keenJumpShootDown2;
CK_action CK_ACT_keenJumpShootDown3;
CK_action CK_ACT_keenPogo1;
CK_action CK_ACT_keenPogo2;
CK_action CK_ACT_keenPogo3;
CK_action CK_ACT_keenHang1;
CK_action CK_ACT_keenHang2;
CK_action CK_ACT_keenPull1;
CK_action CK_ACT_keenPull2;
CK_action CK_ACT_keenPull3;
CK_action CK_ACT_keenPull4;
CK_action CK_ACT_keenPull5;
CK_action CK_ACT_keenPoleSit;
CK_action CK_ACT_keenPoleUp1;
CK_action CK_ACT_keenPoleUp2;
CK_action CK_ACT_keenPoleUp3;
CK_action CK_ACT_keenPoleDown1;
CK_action CK_ACT_keenPoleDown2;
CK_action CK_ACT_keenPoleDown3;
CK_action CK_ACT_keenPoleDown4;
CK_action CK_ACT_keenPoleShoot1;
CK_action CK_ACT_keenPoleShoot2;
CK_action CK_ACT_keenPoleShootUp1;
CK_action CK_ACT_keenPoleShootUp2;
CK_action CK_ACT_keenPoleShootDown1;
CK_action CK_ACT_keenPoleShootDown2;

CK_action CK_ACT_keenShot1;
CK_action CK_ACT_keenShot2;
CK_action CK_ACT_keenShot3;
CK_action CK_ACT_keenShot4;

CK_action CK_ACT_keenShotHit1;
CK_action CK_ACT_keenShotHit2;

CK_action CK_ACT_keenSlide;

CK_action CK_ACT_keenPlaceGem;

CK_action CK_ACT_keenPressSwitch1;
CK_action CK_ACT_keenPressSwitch2;

CK_action CK_ACT_keenEnterDoor1;
CK_action CK_ACT_keenEnterDoor2;
CK_action CK_ACT_keenEnterDoor3;
CK_action CK_ACT_keenEnterDoor4;
CK_action CK_ACT_keenEnterDoor5;
CK_action CK_ACT_keenEnterDoor6;
CK_action CK_ACT_keenEnteredDoor;

CK_action AR_ACT_KeenPulledByVines1;
CK_action AR_ACT_KeenPulledByVines2;
CK_action AR_ACT_KeenPulledByVines3;
CK_action AR_ACT_KeenPulledByVines4;
CK_action AR_ACT_KeenPulledByVines5;
CK_action AR_ACT_KeenPulledByVines6;
CK_action AR_ACT_KeenPulledByVines7;


void CK_KeenColFunc(CK_object *a, CK_object *b);
void CK_IncreaseScore(int score);
void CK_SpawnKeen(int tileX, int tileY, int direction);
void CK_KeenGetTileItem(int tileX, int tileY, int itemNumber);
void CK_GetVitalin(int tileX, int tileY);
void CK_KeenGetTileVitalin(int tileX, int tileY);
void CK_KeenCheckSpecialTileInfo(CK_object *obj);
void CK_KeenPressSwitchThink(CK_object *obj);
boolean CK_KeenPressUp(CK_object *obj);
void CK_KeenSlide(CK_object *obj);
void CK_KeenEnterDoor0(CK_object *obj);
void CK_KeenEnterDoor1(CK_object *obj);
void CK_KeenEnterDoor(CK_object *obj);
void CK_KeenPlaceGem(CK_object *obj);
void CK_KeenRidePlatform(CK_object *obj);
boolean CK_KeenTryClimbPole(CK_object *obj);
void CK_KeenRunningThink(CK_object *obj);
void CK_HandleInputOnGround(CK_object *obj);
void CK_KeenStandingThink(CK_object *obj);
void CK_KeenLookUpThink(CK_object *obj);
void CK_KeenLookDownThink(CK_object *obj);
void CK_KeenDrawFunc(CK_object *obj);
void CK_KeenRunDrawFunc(CK_object *obj);
void CK_KeenReadThink(CK_object *obj);
void CK_KeenJumpThink(CK_object *obj);
void CK_KeenJumpDrawFunc(CK_object *obj);
void CK_KeenPogoBounceThink(CK_object *obj);
void CK_KeenPogoThink(CK_object *obj);
void CK_KeenBreakFuse(int x, int y);
void CK_KeenPogoDrawFunc(CK_object *obj);
void CK_KeenSpecialColFunc(CK_object *obj, CK_object *other);
void CK_KeenSpecialDrawFunc(CK_object *obj);
void CK_KeenHangThink(CK_object *obj);
void CK_KeenPullThink1(CK_object *obj);
void CK_KeenPullThink2(CK_object *obj);
void CK_KeenPullThink3(CK_object *obj);
void CK_KeenPullThink4(CK_object *obj);
void CK_KeenDeathThink(CK_object *obj);
void CK_KillKeen();
void CK_KeenPoleHandleInput(CK_object *obj);
void CK_KeenPoleSitThink(CK_object *obj);
void CK_KeenPoleUpThink(CK_object *obj);
void CK_KeenPoleDownThink(CK_object *obj);
void CK_KeenPoleDownDrawFunc(CK_object *obj);
void CK_SpawnShot(int x, int y, int direction);
void CK_ShotHit(CK_object *obj);
void CK_ShotThink(CK_object *shot);
void CK_ShotDrawFunc(CK_object *obj);
void CK_KeenSpawnShot(CK_object *obj);
void CK_KeenFall(CK_object *obj);

void AR_KeenVines(CK_object *obj);

CK_action CK_ACT_keenStanding = {KEENSTANDLSPR, KEENSTANDRSPR, AT_UnscaledFrame, 0, 1, 4, 0, 32, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenRidePlatform = {0x8B, 0x8B, AT_UnscaledFrame, 0, 1, 4, 0, 32, CK_HandleInputOnGround, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenRidePlatform};

CK_action CK_ACT_keenLookUp1 = {KEENLOOKUPSPR, KEENLOOKUPSPR, AT_UnscaledFrame, 0, 1, 30, 0, 0, CK_KeenLookUpThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenLookUp2};
CK_action CK_ACT_keenLookUp2 = {KEENLOOKUPSPR, KEENLOOKUPSPR, AT_Frame, 0, 1, 0, 0, 0, CK_KeenLookUpThink, CK_KeenColFunc, CK_KeenDrawFunc, NULL};

CK_action CK_ACT_keenLookDown1 = {KEENLOOKDOWN1SPR, KEENLOOKDOWN1SPR, AT_UnscaledFrame, 0, 1, 6, 0, 0, CK_KeenLookDownThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenLookDown2};
CK_action CK_ACT_keenLookDown2 = {KEENLOOKDOWN2SPR, KEENLOOKDOWN2SPR, AT_UnscaledFrame, 0, 1, 0x18, 0, 0, CK_KeenLookDownThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenLookDown3};
CK_action CK_ACT_keenLookDown3 = {KEENLOOKDOWN2SPR, KEENLOOKDOWN2SPR, AT_Frame, 0, 1, 0, 0, 0, CK_KeenLookDownThink, CK_KeenColFunc, CK_KeenDrawFunc, NULL};
CK_action CK_ACT_keenLookDown4 = {KEENLOOKDOWN1SPR, KEENLOOKDOWN1SPR, AT_UnscaledOnce, -1, 1, 6, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenIdle = {KEENLOOKUPSPR, KEENLOOKUPSPR, AT_UnscaledFrame, 0, 1, 0x3C, 0, 0, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenBored1 = {KEENANGRY2SPR, KEENANGRY2SPR, AT_UnscaledFrame, 0, 1, 0x5A, 0, 0, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenBored2};
CK_action CK_ACT_keenBored2 = {KEENANGRY1SPR, KEENANGRY1SPR, AT_UnscaledFrame, 0, 1, 10, 0, 0, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenBored3};
CK_action CK_ACT_keenBored3 = {KEENANGRY2SPR, KEENANGRY2SPR, AT_UnscaledFrame, 0, 1, 0x5A, 0, 0, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenBored4};
CK_action CK_ACT_keenBored4 = {KEENANGRY1SPR, KEENANGRY1SPR, AT_UnscaledFrame, 0, 1, 10, 0, 0, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenBored5};
CK_action CK_ACT_keenBored5 = {KEENANGRY2SPR, KEENANGRY2SPR, AT_UnscaledFrame, 0, 1, 0x5A, 0, 0, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenBored6};
CK_action CK_ACT_keenBored6 = {KEENSHRUGSPR, KEENSHRUGSPR, AT_UnscaledFrame, 0, 1, 0x46, 0, 0, CK_KeenStandingThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenOpenBook1 = {KEENBOOK1SPR, KEENBOOK1SPR, AT_UnscaledOnce, 0, 1, 16, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenOpenBook2};
CK_action CK_ACT_keenOpenBook2 = {KEENBOOK2SPR, KEENBOOK2SPR, AT_UnscaledOnce, 0, 1, 16, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenOpenBook3};
CK_action CK_ACT_keenOpenBook3 = {KEENBOOK3SPR, KEENBOOK3SPR, AT_UnscaledOnce, 0, 1, 16, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenOpenBook4};
CK_action CK_ACT_keenOpenBook4 = {KEENBOOK4SPR, KEENBOOK4SPR, AT_UnscaledOnce, 0, 1, 16, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenReadBook1};

CK_action CK_ACT_keenReadBook1 = {KEENBOOKREADSPR, KEENBOOKREADSPR, AT_UnscaledFrame, 0, 1, 300, 0, 0, CK_KeenReadThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenReadBook2};
CK_action CK_ACT_keenReadBook2 = {KEENBOOKFLIP1SPR, KEENBOOKFLIP1SPR, AT_UnscaledFrame, 0, 1, 16, 0, 0, CK_KeenReadThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenReadBook3};
CK_action CK_ACT_keenReadBook3 = {KEENBOOKFLIP2SPR, KEENBOOKFLIP2SPR, AT_UnscaledFrame, 0, 1, 16, 0, 0, CK_KeenReadThink, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenReadBook1};

CK_action CK_ACT_keenStowBook1 = {KEENPUTBOOKAWAY1SPR, KEENPUTBOOKAWAY1SPR, AT_UnscaledOnce, 0, 1, 12, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStowBook2};
CK_action CK_ACT_keenStowBook2 = {KEENPUTBOOKAWAY2SPR, KEENPUTBOOKAWAY2SPR, AT_UnscaledOnce, 0, 1, 12, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStowBook3};
CK_action CK_ACT_keenStowBook3 = {KEENLOOKATWATCHSPR, KEENLOOKATWATCHSPR, AT_UnscaledOnce, 0, 1, 12, 0, 0, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenNot = {-1, -1, AT_Frame, 0, 0, 10, 0, 0, NULL, NULL, CK_BasicDrawFunc1, NULL};
CK_action CK_ACT_keenDie0 = {KEENDIE1SPR, KEENDIE1SPR, AT_Frame, 0, 0, 0x64, 0, 0, CK_KeenDeathThink, NULL, CK_BasicDrawFunc1, &CK_ACT_keenDie0};
CK_action CK_ACT_keenDie1 = {KEENDIE2SPR, KEENDIE2SPR, AT_Frame, 0, 0, 0x64, 0, 0, CK_KeenDeathThink, NULL, CK_BasicDrawFunc1, &CK_ACT_keenDie1};

CK_action CK_ACT_keenRun1 = {KEENRUNL1SPR, KEENRUNR1SPR, AT_ScaledFrame, 1, 1, 6, 24, 0, CK_KeenRunningThink, CK_KeenColFunc, CK_KeenRunDrawFunc, &CK_ACT_keenRun2};
CK_action CK_ACT_keenRun2 = {KEENRUNL2SPR, KEENRUNR2SPR, AT_ScaledFrame, 1, 1, 6, 24, 0, CK_KeenRunningThink, CK_KeenColFunc, CK_KeenRunDrawFunc, &CK_ACT_keenRun3};
CK_action CK_ACT_keenRun3 = {KEENRUNL3SPR, KEENRUNR3SPR, AT_ScaledFrame, 1, 1, 6, 24, 0, CK_KeenRunningThink, CK_KeenColFunc, CK_KeenRunDrawFunc, &CK_ACT_keenRun4}; 
CK_action CK_ACT_keenRun4 = {KEENRUNL4SPR, KEENRUNR4SPR, AT_ScaledFrame, 1, 1, 6, 24, 0, CK_KeenRunningThink, CK_KeenColFunc, CK_KeenRunDrawFunc, &CK_ACT_keenRun1};

CK_action CK_ACT_keenShoot1 = {KEENSHOOTLEFTSPR, KEENSHOOTRIGHTSPR, AT_UnscaledOnce, 0, 1, 9, 0, 0x20, CK_KeenSpawnShot, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenShoot2};
CK_action CK_ACT_keenShoot2 = {KEENSHOOTLEFTSPR, KEENSHOOTRIGHTSPR, AT_UnscaledOnce, 0, 1, 6, 0, 0x20, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenShootUp1 = {KEENSHOOTUPSPR, KEENSHOOTUPSPR, AT_UnscaledOnce, 0, 1, 9, 0, 0x20, CK_KeenSpawnShot, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenShootUp2};
CK_action CK_ACT_keenShootUp2 = {KEENSHOOTUPSPR, KEENSHOOTUPSPR, AT_UnscaledOnce, 0, 1, 6, 0, 0x20, NULL, CK_KeenColFunc, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenJump1 = {KEENJUMPL1SPR, KEENJUMPR1SPR, AT_Frame, 0, 0, 0, 0, 0, CK_KeenJumpThink, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenJump2};
CK_action CK_ACT_keenJump2 = {KEENJUMPL2SPR, KEENJUMPR2SPR, AT_Frame, 0, 0, 0, 0, 0, CK_KeenJumpThink, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenFall1};

CK_action CK_ACT_keenFall1 = {KEENJUMPL3SPR, KEENJUMPR3SPR, AT_UnscaledFrame, 0, 0, 0x32, 0, 0, CK_KeenJumpThink, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenFall2};
CK_action CK_ACT_keenFall2 = {KEENJUMPL2SPR, KEENJUMPR2SPR, AT_UnscaledFrame, 0, 0, 0x28, 0, 0, CK_KeenJumpThink, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenFall1};

CK_action CK_ACT_keenJumpShoot1 = {KEENJUMPSHOOTLEFTSPR, KEENJUMPSHOOTRIGHTSPR, AT_UnscaledFrame, 0, 0, 9, 0, 0, CK_KeenFall, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenJumpShoot2};
CK_action CK_ACT_keenJumpShoot2 = {KEENJUMPSHOOTLEFTSPR, KEENJUMPSHOOTRIGHTSPR, AT_UnscaledFrame, 1, 0, 1, 0, 0, CK_KeenSpawnShot, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenJumpShoot3};
CK_action CK_ACT_keenJumpShoot3 = {KEENJUMPSHOOTLEFTSPR, KEENJUMPSHOOTRIGHTSPR, AT_UnscaledFrame, 0, 0, 6, 0, 0, CK_KeenFall, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenFall1};

CK_action CK_ACT_keenJumpShootUp1 = {KEENJUMPSHOOTUPSPR, KEENJUMPSHOOTUPSPR, AT_UnscaledFrame, 0, 0, 9, 0, 0, CK_KeenFall, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenJumpShootUp2};
CK_action CK_ACT_keenJumpShootUp2 = {KEENJUMPSHOOTUPSPR, KEENJUMPSHOOTUPSPR, AT_UnscaledFrame, 1, 0, 1, 0, 0, CK_KeenSpawnShot, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenJumpShootUp3};
CK_action CK_ACT_keenJumpShootUp3 = {KEENJUMPSHOOTUPSPR, KEENJUMPSHOOTUPSPR, AT_UnscaledFrame, 0, 0, 6, 0, 0, CK_KeenFall, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenFall1};

CK_action CK_ACT_keenJumpShootDown1 = {KEENJUMPSHOOTDOWNSPR, KEENJUMPSHOOTDOWNSPR, AT_UnscaledFrame, 0, 0, 9, 0, 0, CK_KeenFall, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenJumpShootDown2};
CK_action CK_ACT_keenJumpShootDown2 = {KEENJUMPSHOOTDOWNSPR, KEENJUMPSHOOTDOWNSPR, AT_UnscaledFrame, 1, 0, 1, 0, 0, CK_KeenSpawnShot, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenJumpShootDown3};
CK_action CK_ACT_keenJumpShootDown3 = {KEENJUMPSHOOTDOWNSPR, KEENJUMPSHOOTDOWNSPR, AT_UnscaledFrame, 0, 0, 6, 0, 0, CK_KeenFall, CK_KeenColFunc, CK_KeenJumpDrawFunc, &CK_ACT_keenFall1};

CK_action CK_ACT_keenPogo1 = {KEENPOGOBOUNCELSPR, KEENPOGOBOUNCERSPR, AT_UnscaledOnce, 1, 0, 1, 0, 0, CK_KeenPogoBounceThink, CK_KeenColFunc, CK_KeenPogoDrawFunc, &CK_ACT_keenPogo2};
CK_action CK_ACT_keenPogo2 = {KEENPOGOBOUNCELSPR, KEENPOGOBOUNCERSPR, AT_Frame, 1, 0, 0, 0, 0, CK_KeenPogoThink, CK_KeenColFunc, CK_KeenPogoDrawFunc, &CK_ACT_keenPogo3};
CK_action CK_ACT_keenPogo3 = {KEENPOGOLSPR, KEENPOGORSPR, AT_Frame, 1, 0, 0, 0, 0, CK_KeenPogoThink, CK_KeenColFunc, CK_KeenPogoDrawFunc, NULL};

CK_action CK_ACT_keenHang1 = {KEENHANGLSPR, KEENHANGRSPR, AT_UnscaledOnce, 0, 0, 12, 0, 0, NULL, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenHang2};
CK_action CK_ACT_keenHang2 = {KEENHANGLSPR, KEENHANGRSPR, AT_Frame, 0, 0, 0, 0, 0, CK_KeenHangThink, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, NULL};

CK_action CK_ACT_keenPull1 = {KEENCLIMBL1SPR, KEENCLIMBR1SPR, AT_UnscaledOnce, 0, 0, 10, 0, 0, CK_KeenPullThink1, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPull2};
CK_action CK_ACT_keenPull2 = {KEENCLIMBL2SPR, KEENCLIMBR2SPR, AT_UnscaledOnce, 0, 0, 10, 0, 0, CK_KeenPullThink2, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPull3};
CK_action CK_ACT_keenPull3 = {KEENCLIMBL3SPR, KEENCLIMBR3SPR, AT_UnscaledOnce, 0, 0, 10, 0, 0, CK_KeenPullThink3, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPull4};
CK_action CK_ACT_keenPull4 = {KEENCLIMBL4SPR, KEENCLIMBR4SPR, AT_UnscaledOnce, 0, 0, 10, 0, 0, CK_KeenPullThink4, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPull5};
CK_action CK_ACT_keenPull5 = {KEENSTANDLSPR, KEENSTANDRSPR, AT_UnscaledOnce, 0, 0, 6, 0, 0, NULL, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenPoleSit = {KEENPOLECLIMBL1SPR, KEENPOLECLIMBR1SPR, AT_Frame, 0, 0, 0, 0, 0, CK_KeenPoleSitThink, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleSit};
CK_action CK_ACT_keenPoleUp1 = {KEENPOLECLIMBL1SPR, KEENPOLECLIMBR1SPR, AT_ScaledFrame, 0, 0, 8, 0, 8, CK_KeenPoleUpThink, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleUp2};
CK_action CK_ACT_keenPoleUp2 = {KEENPOLECLIMBL2SPR, KEENPOLECLIMBR2SPR, AT_ScaledFrame, 0, 0, 8, 0, 8, CK_KeenPoleUpThink, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleUp3};
CK_action CK_ACT_keenPoleUp3 = {KEENPOLECLIMBL3SPR, KEENPOLECLIMBR3SPR, AT_ScaledFrame, 0, 0, 8, 0, 8, CK_KeenPoleUpThink, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleUp1};
CK_action CK_ACT_keenPoleDown1 = {KEENPOLESLIDE1SPR, KEENPOLESLIDE1SPR, AT_ScaledOnce, 0, 0, 8, 0, 24, CK_KeenPoleDownThink, CK_KeenSpecialColFunc, CK_KeenPoleDownDrawFunc, &CK_ACT_keenPoleDown2};
CK_action CK_ACT_keenPoleDown2 = {KEENPOLESLIDE2SPR, KEENPOLESLIDE2SPR, AT_ScaledOnce, 0, 0, 8, 0, 24, CK_KeenPoleDownThink, CK_KeenSpecialColFunc, CK_KeenPoleDownDrawFunc, &CK_ACT_keenPoleDown3};
CK_action CK_ACT_keenPoleDown3 = {KEENPOLESLIDE3SPR, KEENPOLESLIDE3SPR, AT_ScaledOnce, 0, 0, 8, 0, 24, CK_KeenPoleDownThink, CK_KeenSpecialColFunc, CK_KeenPoleDownDrawFunc, &CK_ACT_keenPoleDown4};
CK_action CK_ACT_keenPoleDown4 = {KEENPOLESLIDE4SPR, KEENPOLESLIDE4SPR, AT_ScaledOnce, 1, 0, 8, 0, 24, CK_KeenPoleDownThink, CK_KeenSpecialColFunc, CK_KeenPoleDownDrawFunc, &CK_ACT_keenPoleDown1};

CK_action CK_ACT_keenPoleShoot1 = {KEENPOLESHOOTLEFTSPR, KEENPOLESHOOTRIGHTSPR, AT_UnscaledOnce, 0, 0, 9, 0, 0, CK_KeenSpawnShot, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleShoot2};
CK_action CK_ACT_keenPoleShoot2 = {KEENPOLESHOOTLEFTSPR, KEENPOLESHOOTRIGHTSPR, AT_UnscaledOnce, 0, 0, 6, 0, 0, NULL, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleSit};
CK_action CK_ACT_keenPoleShootUp1 = {KEENPOLESHOOTUPLSPR, KEENPOLESHOOTUPRSPR, AT_UnscaledOnce, 0, 0, 9, 0, 0, CK_KeenSpawnShot, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleShootUp2};
CK_action CK_ACT_keenPoleShootUp2 = {KEENPOLESHOOTUPLSPR, KEENPOLESHOOTUPRSPR, AT_UnscaledOnce, 0, 0, 6, 0, 0, NULL, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleSit};
CK_action CK_ACT_keenPoleShootDown1 = {KEENPOLESHOOTDOWNLSPR, KEENPOLESHOOTDOWNRSPR, AT_UnscaledOnce, 0, 0, 9, 0, 0, CK_KeenSpawnShot, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleShootDown2};
CK_action CK_ACT_keenPoleShootDown2 = {KEENPOLESHOOTDOWNLSPR, KEENPOLESHOOTDOWNRSPR, AT_UnscaledOnce, 0, 0, 6, 0, 0, NULL, CK_KeenSpecialColFunc, CK_KeenSpecialDrawFunc, &CK_ACT_keenPoleSit};


// Keen Shots
CK_action CK_ACT_keenShot1 = {STUNNER1SPR, STUNNER1SPR, AT_ScaledOnce, 0, 0, 6, 0x40, 0x40, CK_ShotThink, NULL, CK_ShotDrawFunc, &CK_ACT_keenShot2};
CK_action CK_ACT_keenShot2 = {STUNNER2SPR, STUNNER2SPR, AT_ScaledOnce, 0, 0, 6, 0x40, 0x40, CK_ShotThink, NULL, CK_ShotDrawFunc, &CK_ACT_keenShot3};
CK_action CK_ACT_keenShot3 = {STUNNER3SPR, STUNNER3SPR, AT_ScaledOnce, 0, 0, 6, 0x40, 0x40, CK_ShotThink, NULL, CK_ShotDrawFunc, &CK_ACT_keenShot4};
CK_action CK_ACT_keenShot4 = {STUNNER4SPR, STUNNER4SPR, AT_ScaledOnce, 0, 0, 6, 0x40, 0x40, CK_ShotThink, NULL, CK_ShotDrawFunc, &CK_ACT_keenShot1};

CK_action CK_ACT_keenShotHit1 = {STUNNERDIE1SPR, STUNNERDIE1SPR, AT_UnscaledOnce, 0, 0, 0xC, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_keenShotHit2};
CK_action CK_ACT_keenShotHit2 = {STUNNERDIE2SPR, STUNNERDIE2SPR, AT_UnscaledOnce, 0, 0, 0xC, 0, 0, NULL, NULL, CK_BasicDrawFunc1, NULL};

CK_action CK_ACT_keenSlide = {KEENWALKAWAY1SPR, KEENWALKAWAY1SPR, AT_Frame, 0, 0, 0, 0, 0, CK_KeenSlide, NULL, CK_BasicDrawFunc1, NULL};

CK_action CK_ACT_keenPlaceGem = {KEENWALKAWAY1SPR, KEENWALKAWAY1SPR, AT_UnscaledOnce, 0, 1, 6, 0, 0, CK_KeenPlaceGem, NULL, CK_KeenDrawFunc, &CK_ACT_keenPressSwitch2};

CK_action CK_ACT_keenPressSwitch1 = {KEENWALKAWAY1SPR, KEENWALKAWAY1SPR, AT_UnscaledOnce, 0, 1, 8, 0, 0, CK_KeenPressSwitchThink, NULL, CK_KeenDrawFunc, &CK_ACT_keenPressSwitch2};
CK_action CK_ACT_keenPressSwitch2 = {KEENWALKAWAY1SPR, KEENWALKAWAY1SPR, AT_UnscaledOnce, 0, 1, 8, 0, 0, NULL, NULL, CK_KeenDrawFunc, &CK_ACT_keenStanding};

CK_action CK_ACT_keenEnterDoor1 = {KEENWALKAWAY1SPR, KEENWALKAWAY1SPR, AT_UnscaledOnce, 0, 0, 0x2D, 0, -64, NULL, NULL, CK_BasicDrawFunc1, &CK_ACT_keenEnterDoor2};
CK_action CK_ACT_keenEnterDoor2 = {KEENWALKAWAY1SPR, KEENWALKAWAY1SPR, AT_UnscaledOnce, 0, 0, 9, 0, -64, CK_KeenEnterDoor0, NULL, CK_BasicDrawFunc1, &CK_ACT_keenEnterDoor3};
CK_action CK_ACT_keenEnterDoor3 = {KEENWALKAWAY2SPR, KEENWALKAWAY2SPR, AT_UnscaledOnce, 0, 0, 9, 0, -64, CK_KeenEnterDoor1, NULL, CK_BasicDrawFunc1, &CK_ACT_keenEnterDoor4};
CK_action CK_ACT_keenEnterDoor4 = {KEENWALKAWAY3SPR, KEENWALKAWAY3SPR, AT_UnscaledOnce, 0, 0, 9, 0, -64, CK_KeenEnterDoor0, NULL, CK_BasicDrawFunc1, &CK_ACT_keenEnterDoor5};
CK_action CK_ACT_keenEnterDoor5 = {KEENWALKAWAY4SPR, KEENWALKAWAY4SPR, AT_UnscaledOnce, 0, 0, 9, 0, -64, CK_KeenEnterDoor1, NULL, CK_BasicDrawFunc1, &CK_ACT_keenEnterDoor6};
CK_action CK_ACT_keenEnterDoor6 = {KEENWALKAWAY5SPR, KEENWALKAWAY5SPR, AT_UnscaledOnce, 0, 0, 9, 0, -64, CK_KeenEnterDoor, NULL, CK_BasicDrawFunc1, &CK_ACT_keenStanding};
CK_action CK_ACT_keenEnteredDoor = {-1, -1, AT_UnscaledOnce, 0, 0, 9, 0, -64, &CK_KeenEnterDoor, NULL, CK_BasicDrawFunc1, &CK_ACT_keenStanding};

CK_action AR_ACT_KeenPulledByVines1 = {KEENVINES1SPR, KEENVINES1SPR, AT_UnscaledOnce, 0, 0, 12, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_KeenPulledByVines2};
CK_action AR_ACT_KeenPulledByVines2 = {KEENVINES2SPR, KEENVINES2SPR, AT_UnscaledOnce, 0, 0, 12, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_KeenPulledByVines3};
CK_action AR_ACT_KeenPulledByVines3 = {KEENVINES3SPR, KEENVINES3SPR, AT_UnscaledOnce, 0, 0, 12, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_KeenPulledByVines4};
CK_action AR_ACT_KeenPulledByVines4 = {KEENVINES4SPR, KEENVINES4SPR, AT_UnscaledOnce, 0, 0, 12, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_KeenPulledByVines5};
CK_action AR_ACT_KeenPulledByVines5 = {KEENVINES5SPR, KEENVINES5SPR, AT_UnscaledOnce, 0, 0, 12, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_KeenPulledByVines6};
CK_action AR_ACT_KeenPulledByVines6 = {KEENVINES6SPR, KEENVINES6SPR, AT_UnscaledOnce, 0, 0, 12, 0, 0, NULL, NULL, CK_BasicDrawFunc1, &AR_ACT_KeenPulledByVines7};
CK_action AR_ACT_KeenPulledByVines7 = {-1, -1, AT_UnscaledOnce, 0, 0, 12, 0, 0, AR_KeenVines, NULL, CK_BasicDrawFunc1, &AR_ACT_KeenPulledByVines7};

/*
=============================================================================

						 LOCAL VARIABLES

=============================================================================
*/



#define MISCFLAG_POLE		 1
#define MISCFLAG_DOOR		 2
#define MISCFLAG_SWITCHPLATON	 5
#define MISCFLAG_SWITCHPLATOFF	 6
#define MISCFLAG_GEMHOLDER0	 7
#define MISCFLAG_GEMHOLDER1	 8
#define MISCFLAG_GEMHOLDER2	 9
#define MISCFLAG_GEMHOLDER3	10
#define MISCFLAG_SWITCHBRIDGE	15
#define MISCFLAG_SECURITYDOOR	32



extern CK_object *ck_keenObj;

CK_keenState ck_keenState;

void CK_BasicDrawFunc1(CK_object *obj);

CK_action CK_ACT_itemNotify = {0, 0, AT_ScaledOnce, 0, 0, 40, 0, 8, 0, 0, CK_BasicDrawFunc1, 0};

soundnames CK5_ItemSounds[]  = { GOTGEMSND, GOTGEMSND, GOTGEMSND, GOTGEMSND,
                               GOTITEMSND,GOTITEMSND,GOTITEMSND,GOTITEMSND,GOTITEMSND,GOTITEMSND,
                               GOTEXTRALIFESND, GOTSTUNNERSND, GOTEXTRALIFESND
};

unsigned CK5_ItemPoints[]  = {  0,   0,   0,   0, 100, 200, 500, 1000, 2000, 5000,   0,   0,   0};
unsigned CK5_ItemShadows[] = {GEMSHADOWSPR, GEMSHADOWSPR, GEMSHADOWSPR, GEMSHADOWSPR, POINTS100SHADOWSPR, POINTS200SHADOWSPR, POINTS500SHADOWSPR,  POINTS1000SHADOWSPR,  POINTS2000SHADOWSPR,  POINTS5000SHADOWSPR, POINTS1UPSHADOWSPR, STUNNERSHADOWSPR, ITEM1UPSHADOW};


void CK_IncreaseScore(int score);

void CK_KeenColFunc(CK_object *a, CK_object *b)
{
	if (b->type == 5)
	{
		if (b->user1 > 12)
			return;

		SD_PlaySound(CK5_ItemSounds[b->user1]);

		b->type = 1;
		b->zLayer = 3;
		b->gfxChunk = CK5_ItemShadows[b->user1];

		CK_IncreaseScore(CK5_ItemPoints[b->user1]);

		//b->yDirection = -1;

		if (b->user1 < 4)
		{
			ck_gameState.keyGems[b->user1]++;
		}
		else if (b->user1 == 10)
		{
			ck_gameState.numLives++;
		}
		else if (b->user1 == 11)
		{
			ck_gameState.numShots += (ck_gameState.difficulty == D_Easy)?8:5;
		}
		else if (b->user1 == 12)
		{
			ck_gameState.numLives += 3;
		}
		CK_SetAction2(b, &CK_ACT_itemNotify);
	}
	else if (b->type == 6) //Platform
	{
		if (!ck_keenState.platform)
			CK_PhysPushY(a,b);
	}
	else if (b->type == CT_Larvbat)
	{
		CK_PhysPushX(a, b);
		return;
	}
}

int ck_KeenRunXVels[8] = {0, 0, 4, 4, 8, -4, -4, -8};

int ck_KeenPoleOffs[3] = {-8, 0, 8};


void CK_IncreaseScore(int score)
{
	ck_gameState.keenScore += score;
	if (DemoMode != demo_Off) return;
	if (ck_gameState.keenScore > ck_gameState.nextKeenAt)
	{
		SD_PlaySound(GOTEXTRALIFESND);
		ck_gameState.numLives++;
		ck_gameState.nextKeenAt *= 2;
	}	
}

void CK_SpawnKeen(int tileX, int tileY, int direction)
{
	if (mapon==16 && ck_gameState.levelsDone[16] == true)
		return;

	ck_keenObj->type = CT_Player; //TODO: obj_keen
	ck_keenObj->active = OBJ_ALWAYS_ACTIVE; 
	ck_keenObj->visible = true;
	ck_keenObj->zLayer = 1;
	ck_keenObj->clipped = CLIP_normal;
	ck_keenObj->posX = (tileX << 8);
	ck_keenObj->posY = (tileY << 8) - 241;
	ck_keenObj->xDirection = direction;
	ck_keenObj->yDirection = 1;
	CK_SetAction(ck_keenObj, &CK_ACT_keenStanding);
}

void CK_SpawnBossKeen(int tileX, int tileY, int direction)
{
	if (mapon==16 && ck_gameState.levelsDone[16] == true)
	{
		ck_keenObj->type = CT_Player; //TODO: obj_keen
		ck_keenObj->active = OBJ_ALWAYS_ACTIVE; 
		ck_keenObj->visible = true;
		ck_keenObj->zLayer = 1;
		ck_keenObj->clipped = CLIP_normal;
		ck_keenObj->posX = (tileX << 8);
		ck_keenObj->posY = (tileY << 8) - 241;
		ck_keenObj->xDirection = direction;
		ck_keenObj->yDirection = 1;
		CK_SetAction(ck_keenObj, &CK_ACT_keenStanding);
	}

}

static unsigned emptyTile = 0;

void CK_KeenGetTileItem(int tileX, int tileY, int itemNumber)
{
	CK_object *notify;

	RF_MemToMap(&emptyTile, 1, tileX, tileY, 1, 1);
	SD_PlaySound(CK5_ItemSounds[itemNumber]);

	CK_IncreaseScore(CK5_ItemPoints[itemNumber]);

	switch (itemNumber)
	{
		case 10:
			ck_gameState.numLives++;
			break;
		case 11:
			ck_gameState.numShots += (ck_gameState.difficulty == D_Easy)?8:5;
			break;
	}

	notify = CK_GetNewObj(true);
	notify->type = 1;
	notify->zLayer = 3;
	notify->posX = tileX << 8;
	notify->posY = tileY << 8;
	notify->yDirection = -1;
	notify->user2 = CK5_ItemShadows[itemNumber];
	notify->gfxChunk = notify->user2;
	CK_SetAction(notify, &CK_ACT_itemNotify);
	notify->clipped = CLIP_not;
}

void CK_GetVitalin(int tileX, int tileY)
{
	CK_object *notify = CK_GetNewObj(true);
	notify->type = 1;
	notify->clipped = CLIP_not;
	notify->zLayer = 3;
	notify->posX = tileX << 8;
	notify->posY = tileY << 8;
	
	CK_SetAction(notify, &CK_ACT_VitalinNotify1);
}

void CK_KeenGetTileVitalin(int tileX, int tileY)
{
	RF_MemToMap(&emptyTile, 1, tileX, tileY, 1, 1);
	SD_PlaySound(GOTVITALINSND);
	CK_GetVitalin(tileX, tileY);

	// Award extra life at 100 vitalins
	if (++ck_gameState.numVitalin == 100)
	{
		CK_object *newobj;

		ck_gameState.numVitalin = 0;
		SD_PlaySound(GOTEXTRALIFESND);
		ck_gameState.numLives++;
		newobj = CK_GetNewObj(true);
		newobj->type = CT_Friendly;
		newobj->zLayer = PRIORITIES - 1;
		newobj->posX = tileX << G_T_SHIFT;
		newobj->posY = tileY << G_T_SHIFT;
		newobj->yDirection = motion_Up;
		newobj->user2 = newobj->gfxChunk = VITALIN1UPSHADOWSPR;
		CK_SetAction(newobj, &CK_ACT_itemNotify);
		newobj->clipped = CLIP_not;
	}
}

void CK_KeenCheckSpecialTileInfo(CK_object *obj)
{
	int x,y, specialTileInfo, targetXUnit;

	if (ck_gameState.vines == 1)
		ck_gameState.vines = 0;

	for (y = obj->clipRects.tileY1; y <= obj->clipRects.tileY2; ++y)
	{
		for (x = obj->clipRects.tileX1; x <= obj->clipRects.tileX2; ++x)
		{
			specialTileInfo =  (TI_ForeMisc(CA_TileAtPos(x,y,1)) & 0x7F);
			switch (specialTileInfo)
			{
			case 0: break;
			case 3:
				CK_KillKeen();
				break;
			case 4:
				CK_KeenGetTileVitalin(x,y);
				break;
			case MISCFLAG_GEMHOLDER0:
			case MISCFLAG_GEMHOLDER1:
			case MISCFLAG_GEMHOLDER2:
			case MISCFLAG_GEMHOLDER3:
				if (y == obj->clipRects.tileY2 && obj->topTI && obj->currentAction != &CK_ACT_keenPlaceGem
					&& ck_gameState.keyGems[specialTileInfo - MISCFLAG_GEMHOLDER0])
				{
					targetXUnit = (x << 8) - 64;
					if (obj->posX == targetXUnit)
					{
						ck_gameState.keyGems[specialTileInfo - MISCFLAG_GEMHOLDER0]--;
						CK_SetAction2(obj, &CK_ACT_keenPlaceGem);
					}
					else
					{
						obj->user1 = targetXUnit;
						obj->currentAction = &CK_ACT_keenSlide;
					}
				}
				return;

			case 16:
				if (ck_gameState.vines == 0)
				{
					unsigned infovalue = *((unsigned _seg *)mapsegs[2] + mapbwidthtable[y]/2 + x);
					// Second hack: don't pull if keen isn't standing
					if (!ck_keenObj->topTI)
						break;
					
					ck_gameState.mapPosX = (infovalue >> 8) << G_T_SHIFT;
					ck_gameState.mapPosY = (infovalue & 0xFF) << G_T_SHIFT;
					// Hack: just pull keen right away
					ck_scrollDisabled = true;
					obj->currentAction = &AR_ACT_KeenPulledByVines1;
					obj->clipped = CLIP_not;
					ck_gameState.vines = 2;
					return;
					//ck_gameState.vines = 1;
				}
				break;

			case 21:
			case 22:
			case 23:
			case 24:
			case 25:
			case 26:
			case 27:
			case 28:
			case 29:
				CK_KeenGetTileItem(x,y,specialTileInfo - 17);
				/*CK_KeenGetTileItem(x,y,specialTileInfo - 21 + 4);*/
				break;
			}
		}
	}
}

// Fleexy's code
boolean CK_AR_SwitchFlipWorker(int xpos, int ypos, int type, int animSwitch) {
        // type: 0 for foreground, 1 for infoplane, 2 for N/A
        // xpos and ypos are of the switch, not the target
        // animSwitch: 0 for not-an-actual-switch (check type), 1 for normal (check tileinfo), 2 for "just animate the switch"
        unsigned switchTarget = CA_TileAtPos(xpos, ypos, 2);
        int switchTargetX = (switchTarget >> 8);
        int switchTargetY = (switchTarget & 0xFF);
        int infoPlaneInverses[8] = {2,3,0,1,6,7,4,5};
        unsigned switchTile;
        char switchMisc;
        unsigned switchNextTile;
        int tileY, tileX;              // Used for
        unsigned currentTile, newTile; //  bridge switches
        unsigned infoPlaneValue; // Used for info switches
        if (animSwitch > 0) {
                switchTile = CA_TileAtPos(xpos, ypos, 1);
                switchMisc = TI_ForeMisc(switchTile);
                if (switchMisc != MISCFLAG_SWITCHBRIDGE && switchMisc != MISCFLAG_SWITCHPLATON && switchMisc != MISCFLAG_SWITCHPLATOFF) return false;
                switchNextTile = switchTile + TI_ForeAnimTile(switchTile);
                RF_MemToMap(&switchNextTile, 1, xpos, ypos, 1, 1);
        } else {
                if (switchTarget < 0x100) return false;
        }
        if ((animSwitch == 0 && type == 0) || (animSwitch == 1 && switchMisc == MISCFLAG_SWITCHBRIDGE)) {
                for (tileY = switchTargetY; tileY < switchTargetY + 2; ++tileY)
                {
                        for (tileX = switchTargetX - ((tileY == switchTargetY)? 0 : 1); tileX < mapwidth; ++tileX)
                        {
                                currentTile = CA_TileAtPos(tileX, tileY, 1);
                                if (!TI_ForeAnimTile(currentTile)) break;
                                newTile = currentTile + TI_ForeAnimTile(currentTile);
                                RF_MemToMap(&newTile, 1, tileX, tileY, 1, 1);
                        }
                }
        } else if ((animSwitch == 0 && type == 1) || (animSwitch == 1)) {
                infoPlaneValue = CA_TileAtPos(switchTargetX, switchTargetY, 2);
                if (infoPlaneValue >= 91 && infoPlaneValue < 99)
                {
                        // Invert the direction of the goplat arrow.
                        infoPlaneValue = infoPlaneInverses[infoPlaneValue - 91] + 91;
                }
                else
                {
                        // Insert or remove a [B] block.
                        infoPlaneValue ^= 0x1F;
                }
               
                *(mapsegs[2] + (switchTargetY*mapwidth + switchTargetX)) = infoPlaneValue;
        }
        return true;
}
 
void CK_KeenPressSwitchThink(CK_object *obj)
{
        int switchX = obj->clipRects.tileXmid;
        int switchY = obj->clipRects.tileY1;
        unsigned switchTarget = CA_TileAtPos(switchX, switchY, 2);
        unsigned switchTile = CA_TileAtPos(switchX, switchY, 1);
        char switchMisc = TI_ForeMisc(switchTile);
        int type = (switchMisc == MISCFLAG_SWITCHBRIDGE) ? 0 : 1;
 
        SD_PlaySound(KEENOUTOFAMMOSND);
 
        if (switchTarget == 0xF1EE) {
                // It's a stack of infoplane values all with this type
                CK_AR_SwitchFlipWorker(switchX, switchY, 0, 2); // Animate the real switch
                while (true) {
                        switchY--;
                        if (!CK_AR_SwitchFlipWorker(switchX, switchY, type, 0)) break;
                }
        } else {
                // It's a stack of switches each with their own type
                while (true) {
                        if (!CK_AR_SwitchFlipWorker(switchX, switchY, 2, 1)) break;
                        switchY--;
                }
        }
}
#if 0
void CK_KeenPressSwitchThink(CK_object *obj)
{
	int tileY, tileX;
	unsigned currentTile, newTile;
	int infoPlaneInverses[8] = {2,3,0,1,6,7,4,5};
	unsigned infoPlaneValue;
	unsigned switchTarget = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY1, 2);
	int switchTargetX = (switchTarget >> 8);
	int switchTargetY = (switchTarget & 0xFF);
	unsigned switchTile = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY1, 1);
	char switchMisc = TI_ForeMisc(switchTile);

	// Toggle the switch.
	unsigned switchNextTile = switchTile + TI_ForeAnimTile(switchTile);
	RF_MemToMap(&switchNextTile, 1, obj->clipRects.tileXmid, obj->clipRects.tileY1, 1, 1);
	SD_PlaySound(KEENOUTOFAMMOSND);

	if (switchMisc == MISCFLAG_SWITCHBRIDGE)
	{
		for (tileY = switchTargetY; tileY < switchTargetY + 2; ++tileY)
		{
			for (tileX = switchTargetX - ((tileY == switchTargetY)? 0 : 1); tileX < mapwidth; ++tileX)
			{
				currentTile = CA_TileAtPos(tileX, tileY, 1);
				if (!TI_ForeAnimTile(currentTile)) break;
				newTile = currentTile + TI_ForeAnimTile(currentTile);
				RF_MemToMap(&newTile, 1, tileX, tileY, 1, 1);
			} 
		}
	}
	else
	{
		infoPlaneValue = CA_TileAtPos(switchTargetX, switchTargetY, 2);
		if (infoPlaneValue >= 91 && infoPlaneValue < 99)
		{
			// Invert the direction of the goplat arrow.
			infoPlaneValue = infoPlaneInverses[infoPlaneValue - 91] + 91;
		}
		else
		{
			// Insert or remove a [B] block.
			infoPlaneValue ^= 0x1F;
		}
		
		*(mapsegs[2] + (switchTargetY*mapwidth + switchTargetX)) = infoPlaneValue;
	}
}
#endif


boolean CK_KeenPressUp(CK_object *obj)
{
	CK_object *newObj;
	int destXunit;

	unsigned destUnitX;
	char miscFlagLeft;


	char tileMiscFlag = TI_ForeMisc(CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY1, 1));

	// Are we pressing a switch?
	if (tileMiscFlag == MISCFLAG_SWITCHPLATON || tileMiscFlag == MISCFLAG_SWITCHPLATOFF || tileMiscFlag == MISCFLAG_SWITCHBRIDGE)
	{
		destXunit = (obj->clipRects.tileXmid << 8) - 64;
		if (obj->posX == destXunit)
		{
			// Flip that switch!
			obj->currentAction = &CK_ACT_keenPressSwitch1;
		}
		else
		{
			obj->user1 = destXunit;
			obj->currentAction = &CK_ACT_keenSlide;
		}
		ck_keenState.keenSliding = true;
		return true;
	}

	// Are we enterting a door?
	if (tileMiscFlag == MISCFLAG_DOOR || tileMiscFlag == MISCFLAG_SECURITYDOOR )
	{
		destUnitX = (obj->clipRects.tileXmid << 8) + 96;

		// If the door is two tiles wide, we want to be in the centre.
		miscFlagLeft = TI_ForeMisc(CA_TileAtPos(obj->clipRects.tileXmid - 1, obj->clipRects.tileY1, 1));
		if (miscFlagLeft == MISCFLAG_DOOR || miscFlagLeft == MISCFLAG_SECURITYDOOR)
		{
			destUnitX -= 256;
		}

		if (obj->posX == destUnitX)
		{
			//We're at the door.
			
			// Is it a security door?
			if (tileMiscFlag == MISCFLAG_SECURITYDOOR)
			{
				/*
				if (ck_gameState.securityCard)
				{
					ck_gameState.securityCard = 0;
					SD_PlaySound(OPENSECURITYDOORSND);
					newObj = CK_GetNewObj(false);
					newObj->posX = obj->clipRects.tileXmid - 2;
					newObj->posY = obj->clipRects.tileY2 - 4;
					newObj->active = OBJ_ALWAYS_ACTIVE;
					newObj->type = 1;
					CK_SetAction(newObj, &CK_ACT_SecurityDoorOpen);
					obj->currentAction = &CK_ACT_keenEnterDoor1;
					obj->zLayer = 0;
					ck_keenState.keenSliding = true;
					return true;
				}
				else
				*/
				{
					SD_PlaySound(NEEDKEYCARDSND);
					obj->currentAction = &CK_ACT_keenStanding;
					ck_keenState.keenSliding = true;
					return false;
				}
			}
			else
			{
				ck_invincibilityTimer = 110;
				obj->currentAction = &CK_ACT_keenEnterDoor2;
				obj->zLayer = 0;

#if 0
				if (!CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY1, 2))
				{
					CK5_SpawnLightning();
				}
#endif
			}
		}
		else
		{
			obj->user1 = destUnitX;
			obj->currentAction = &CK_ACT_keenSlide;
		}

		ck_keenState.keenSliding = true;

		return true;
	}


	// No? Return to our caller, who will handle poles/looking up.
	return false;
}
	
// Think function for keen "sliding" towards a switch, keygem or door.
void CK_KeenSlide(CK_object *obj)
{
	int deltaX = obj->user1 - obj->posX;
	if (deltaX < 0)
	{
		// Move left one px per tick.
		ck_nextX -= tics * 16;
		// If we're not at our target yet, return.
		if (ck_nextX > deltaX) return;
	}
	else if (deltaX > 0)
	{
		// Move right one px per tick.
		ck_nextX += tics * 16;
		// If we're not at our target yet, return.
		if (ck_nextX < deltaX) return;
	}

	// We're at our target.
	ck_nextX = deltaX;
	obj->user1 = 0;
	if (!CK_KeenPressUp(obj))
	{
		obj->currentAction = &CK_ACT_keenStanding;
	}
}

void CK_KeenEnterDoor0(CK_object *obj)
{
	SD_PlaySound(KEENWALK0SND);
}

void CK_KeenEnterDoor1(CK_object *obj)
{
	SD_PlaySound(KEENWALK1SND);
}

// Think function for entering a door.
void CK_KeenEnterDoor(CK_object *obj)
{
	unsigned destination = CA_TileAtPos(obj->clipRects.tileX1, obj->clipRects.tileY2, 2);

	if (destination == 0x0000)
	{
		ck_levelState = 13;
		obj->currentAction = &CK_ACT_keenEnteredDoor;
		return;
	}

	if (destination == 0xB1B1)
	{
		ck_levelState = 2;
		obj->currentAction = &CK_ACT_keenEnteredDoor;
		return;
	}

	obj->posY = ((destination&0xFF) << 8) - 256 + 15;
	obj->posX = ((destination >> 8) << 8);
	obj->zLayer = 1;
	obj->clipped = CLIP_not;
	CK_SetAction2(obj, obj->currentAction->next);
	obj->clipped = CLIP_normal;
	CK_CentreCamera(obj);
}

void CK_KeenPlaceGem(CK_object *obj)
{
	CK_object *newObj;
	int doorHeight, doorY;
	unsigned doorTile;

	unsigned oldFGTile = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY2, 1);
	unsigned newFGTile = oldFGTile + 18;
	unsigned target = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY2, 2);

	unsigned targetX = target >> 8;
	unsigned targetY = target & 0xFF;

	RF_MemToMap(&newFGTile, 1, obj->clipRects.tileXmid, obj->clipRects.tileY2, 1, 1);

	SD_PlaySound(OPENGEMDOORSND);
	
	newObj = CK_GetNewObj(false);

	newObj->posX = targetX;
	newObj->posY = targetY;

	if (targetX > mapwidth || targetX < 2 || targetY > mapheight || targetY < 2)
	{
		Quit("Keyholder points to a bad spot!");
	}

	// Calculate the height of the door.
	doorHeight = 0;
	doorY = targetY;
	doorTile = CA_TileAtPos(targetX, doorY, 1);
	do
	{
		doorHeight++;
		doorY++;
	} while (CA_TileAtPos(targetX, doorY, 1) == doorTile);

	newObj->user1 = doorHeight;
	newObj->clipped = CLIP_not;
	newObj->type = CT_Friendly;
	newObj->active = OBJ_ALWAYS_ACTIVE;
	CK_SetAction(newObj, &CK_ACT_DoorOpen1);
}

void CK_KeenRidePlatform(CK_object *obj)
{
	// Save the platform pointer, we might be wiping it.
	CK_object *plat = ck_keenState.platform;


	if (obj->clipRects.unitX2 < plat->clipRects.unitX1 || obj->clipRects.unitX1 > plat->clipRects.unitX2)
	{
		// We've fallen off the platform horizontally.
		ck_keenState.platform = 0;
		return;
	}

	if (obj->deltaPosY < 0)
	{
		// If we've jumped off the platform.
		ck_keenState.platform = 0;
		if (plat->deltaPosY < 0)
		{
			ck_nextX = 0;
			ck_nextY = plat->deltaPosY;
			CK_PhysUpdateSimpleObj(obj);
			return;
		}
	}
	else
	{
		//Ride the platform
		ck_nextX = plat->deltaPosX;
		ck_nextY = plat->clipRects.unitY1 - obj->clipRects.unitY2 - 16;
		CK_PhysUpdateSimpleObj(obj);

		// Keen has a "/NOPAN" parameter which disables use of the EGA panning
		// register. In order to make platforms less ugly when this is on
		// (though not much less ugly, IMHO), we would do some more processing here.
		// As is, we just do the line below, to keep keen at the same position while scrolling.	

		// Keen's x position should move with 2px granularity when on a platform so that scrolling
		// looks nice. (Keen will stay at the same pixel position when scrolling, as we scroll 2px at a time).
		obj->posX |= plat->posX & 0x1F;

		// We've hit the ceiling?
		if (obj->bottomTI)
		{
			ck_keenState.platform = 0;
			return;
		}


		// We're standing on something, don't fall down!
		obj->topTI = 0x19;
	}
}


boolean CK_KeenTryClimbPole(CK_object *obj)
{
	unsigned candidateTile;

	if (lasttimecount < ck_keenState.poleGrabTime)
		ck_keenState.poleGrabTime = 0;
	else if (lasttimecount - ck_keenState.poleGrabTime < 19)
		return false;

	candidateTile = CA_TileAtPos(obj->clipRects.tileXmid, ((ck_inputFrame.yaxis==-1)?((obj->clipRects.unitY1+96)>>8):(obj->clipRects.tileY2+1)), 1);


	if ((TI_ForeMisc(candidateTile) & 0x7F) == 1)
	{
		obj->posX = 128 + ((obj->clipRects.tileXmid - 1) << 8);
		ck_nextX = 0;
		ck_nextY = (ck_inputFrame.yaxis << 5);
		obj->clipped = CLIP_not;
		obj->currentAction = &CK_ACT_keenPoleSit;
		return true;
	}
	return false;
}

void CK_KeenRunningThink(CK_object *obj)
{
	if (!ck_inputFrame.xaxis)
	{
		obj->currentAction = &CK_ACT_keenStanding;
		CK_HandleInputOnGround(obj);
		return;
	}

	obj->xDirection = ck_inputFrame.xaxis;
	
	if (ck_inputFrame.yaxis == -1)
	{
		if (CK_KeenTryClimbPole(obj)) return;
		if (ck_keenState.keenSliding || CK_KeenPressUp(obj))
			return;
	}
	else if (ck_inputFrame.yaxis == 1)
	{
		if (CK_KeenTryClimbPole(obj)) return;
	}

	if (ck_keenState.shootIsPressed && !ck_keenState.shootWasPressed)
	{
		ck_keenState.shootWasPressed = true;
		
		if (ck_inputFrame.yaxis == -1)
		{
			obj->currentAction = &CK_ACT_keenShootUp1;
		}
		else
		{
			obj->currentAction = &CK_ACT_keenShoot1;
		}
		return;
	}

	if (ck_keenState.jumpIsPressed && !ck_keenState.jumpWasPressed)
	{
		ck_keenState.jumpWasPressed = true;
		SD_PlaySound(KEENJUMPSND);
		obj->velX = obj->xDirection * 16;
		obj->velY = -40;
		ck_nextX = ck_nextY = 0;
		ck_keenState.jumpTimer = 18;
		obj->currentAction = &CK_ACT_keenJump1;
		// Is this the mystical 'impossible pogo'?
		// k5disasm has a 'return' here, probably a mistake?
	}

	if (ck_keenState.pogoIsPressed && !ck_keenState.pogoWasPressed)
	{
		ck_keenState.pogoWasPressed = true;
		obj->currentAction = &CK_ACT_keenPogo1;
		SD_PlaySound(KEENJUMPSND);
		obj->velX = obj->xDirection * 16;
		obj->velY = -48;
		// Should this be nextY? Andy seems to think so, but lemm thinks that X is right...
		ck_nextX = 0;
		ck_keenState.jumpTimer = 24;
		return;
	}

	// Andy seems to think this is Y as well. Need to do some more disasm.
	// If this is an X vel, then surely we'd want to multiply it by the direction?
	// TODO: investigate

	// While the Keen 5 Disassembly does set ck_nextX here, it would make more sense if ck_nextY 
	// were being set.
	ck_nextX += ck_KeenRunXVels[obj->topTI&7] * tics;

	if ((obj->currentAction->chunkLeft == CK_ACT_keenRun1.chunkLeft) && !(obj->user3))
	{
		SD_PlaySound(KEENWALK0SND);
		obj->user3 = 1;
		return;
	}

	if ((obj->currentAction->chunkLeft == CK_ACT_keenRun3.chunkLeft) && !(obj->user3))
	{
		SD_PlaySound(KEENWALK1SND);
		obj->user3 = 1;
		return;
	}
	if ((obj->currentAction->chunkLeft == CK_ACT_keenRun2.chunkLeft) || (obj->currentAction->chunkLeft == CK_ACT_keenRun4.chunkLeft))
	{
		obj->user3 = 0;
	}
}



void CK_HandleInputOnGround(CK_object *obj)
{
	// If we're riding a platform, do it surfin' style!)
	if (obj->topTI == 0x19)
	{
		// But only if such an action exists in this episode. :/
#ifdef KEEN5
		if (&CK_ACT_keenRidePlatform)
		{
			obj->currentAction = &CK_ACT_keenRidePlatform;
		}
#endif
	}

	if (ck_inputFrame.xaxis)
	{
		obj->currentAction = &CK_ACT_keenRun1;
		CK_KeenRunningThink(obj);
		ck_nextX = (int)(obj->xDirection * obj->currentAction->velX * tics)/4;
		return;
	}

	if (ck_keenState.shootIsPressed && !ck_keenState.shootWasPressed)
	{
		ck_keenState.shootWasPressed = true;
		if (ck_inputFrame.yaxis == -1)
		{
			obj->currentAction = &CK_ACT_keenShootUp1;
		}
		else
		{
			obj->currentAction = &CK_ACT_keenShoot1;
		}
		return;
	}

	if (ck_keenState.jumpIsPressed && !ck_keenState.jumpWasPressed)
	{
		ck_keenState.jumpWasPressed = true;
		SD_PlaySound(KEENJUMPSND);
		obj->velX = 0;
		obj->velY = -40;
		ck_nextY = 0;
		ck_keenState.jumpTimer = 18;
		obj->currentAction = &CK_ACT_keenJump1;
		return;
	}

	if (ck_keenState.pogoIsPressed && !ck_keenState.pogoWasPressed)
	{
		ck_keenState.pogoWasPressed = true;
		SD_PlaySound(KEENJUMPSND);
		obj->currentAction = &CK_ACT_keenPogo1;
		obj->velX = 0;
		obj->velY = -48;
		ck_nextY = 0;
		ck_keenState.jumpTimer = 24;
		return;
	}

	if (ck_inputFrame.yaxis == -1)
	{
		if (CK_KeenTryClimbPole(obj)) return;
		if (!ck_keenState.keenSliding && CK_KeenPressUp(obj)) return;
		obj->currentAction = &CK_ACT_keenLookUp1;
	}	
	else if (ck_inputFrame.yaxis == 1)
	{
		// Try poles.
		if (CK_KeenTryClimbPole(obj)) return;
		// Keen looks down.
		obj->currentAction = &CK_ACT_keenLookDown1;
		return;
	}
		
}

void CK_KeenStandingThink(CK_object *obj)
{
	// If we're riding a platform, do it surfin' style!
	if (obj->topTI == 0x19)
	{
		// But only if such an action exists in this episode. :/
#ifdef KEEN5
		if (&CK_ACT_keenRidePlatform)
		{
			obj->currentAction = &CK_ACT_keenRidePlatform;
		}
#endif
	}

	if (ck_inputFrame.xaxis || ck_inputFrame.yaxis || ck_keenState.jumpIsPressed || ck_keenState.pogoIsPressed || ck_keenState.shootIsPressed )
	{
		obj->user1 = obj->user2 = 0;	//Idle Time + Idle State
		obj->currentAction = &CK_ACT_keenStanding;
		CK_HandleInputOnGround(obj);

		return;
	}

	//If not on platform
	if ((obj->topTI & ~7) != 0x18)
		obj->user1 += tics;

	if (obj->user2 == 0 && obj->user1 > 200)
	{
		if (ck_gameState.vines == 1)
		{
			ck_scrollDisabled = true;
			obj->currentAction = &AR_ACT_KeenPulledByVines1;
			obj->clipped = CLIP_not;
			ck_gameState.vines = 2;
		}
		else
		{
			obj->user2++;
			obj->currentAction = &CK_ACT_keenIdle;
			obj->user1 = 0;
		}
		return;
	}

	if (obj->user2 == 1 && obj->user1 > 300)
	{
		obj->user2++;
		obj->currentAction = &CK_ACT_keenBored1;
		obj->user1 = 0;
		return;
	}

	if (obj->user2 == 2 && obj->user1 > 700)
	{
		obj->user2++;
		obj->user1 = 0;
		obj->currentAction = &CK_ACT_keenOpenBook1;
	}

}

void CK_KeenLookUpThink(CK_object *obj)
{
	if (ck_inputFrame.yaxis != -1 ||
			ck_inputFrame.xaxis != 0 ||
			(ck_keenState.jumpIsPressed && !ck_keenState.jumpWasPressed) ||
			(ck_keenState.pogoIsPressed && !ck_keenState.pogoWasPressed) ||
			(ck_keenState.shootIsPressed))
	{
		obj->currentAction = &CK_ACT_keenStanding;
		CK_HandleInputOnGround(obj);
	}
}

void CK_KeenLookDownThink(CK_object *obj)
{
	int tile1, tile2;
	unsigned deltay;

	//Try to jump down
	if (ck_keenState.jumpIsPressed && !ck_keenState.jumpWasPressed && (obj->topTI&7) == 1)
	{
		ck_keenState.jumpWasPressed = true;

		//If the tiles below the player are blocking on any side but the top, they cannot be jumped through
		tile1 = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY2, 1);
		tile2 = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY2+1, 1);
		
		if (TI_ForeLeft(tile1) || TI_ForeBottom(tile1) || TI_ForeRight(tile1))
			return;

		if (TI_ForeLeft(tile2) || TI_ForeBottom(tile2) || TI_ForeRight(tile2))
			return;
		#define max(a,b) (((a)>(b))?(a):(b))

		deltay = max(tics,4) << 4;
	
		//Moving platforms
		if (ck_keenState.platform)
			deltay += ck_keenState.platform->deltaPosY;

		ck_keenState.platform = 0;


		obj->clipRects.unitY2 += deltay;
		obj->posY += deltay;
		ck_nextX = 0;
		ck_nextY = 0;
		obj->currentAction = &CK_ACT_keenFall1;
		obj->velX = obj->velY = 0;
		SD_PlaySound(KEENFALLSND);
		return;
	}
	

	if (ck_inputFrame.yaxis != 1 || ck_inputFrame.xaxis != 0 || (ck_keenState.jumpIsPressed && !ck_keenState.jumpWasPressed)
		|| (ck_keenState.pogoIsPressed && !ck_keenState.pogoWasPressed))
	{
		obj->currentAction = &CK_ACT_keenLookDown4;
		return;
	}
}	

// TODO: More to modify here
void CK_KeenDrawFunc(CK_object *obj)
{
	if (!obj->topTI)
	{
		SD_PlaySound(KEENFALLSND);
		obj->velX = obj->xDirection * 8;
		obj->velY = 0;
		CK_SetAction2(obj, &CK_ACT_keenFall1);
		ck_keenState.jumpTimer = 0;
	}
	else if ((obj->topTI & 0xFFF8) == 8)
	{
		CK_KillKeen();
	}
	else if (obj->topTI == 0x29)
	{
		// Keen6 conveyor belt right
		ck_nextX = tics * 8;
		ck_nextY = 0;
		obj->user1 = 0;
		CK_PhysUpdateNormalObj(obj);
	}
	else if (obj->topTI == 0x31)
	{
		// Keen6 conveyor belt left
		ck_nextX = tics * -8;
		ck_nextY = 0;
		obj->user1 = 0;
		CK_PhysUpdateNormalObj(obj);
	}
	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
}

// TODO: More to modify here
void CK_KeenRunDrawFunc(CK_object *obj)
{

	if (!obj->topTI)
	{
		SD_PlaySound(KEENFALLSND);
		obj->velX = obj->xDirection * 8;
		obj->velY = 0;
		CK_SetAction2(obj, &CK_ACT_keenFall1);
		ck_keenState.jumpTimer = 0;
	}
	else if ((obj->topTI & 0xFFF8) == 8)
	{
		CK_KillKeen();
	}
	else if (obj->topTI == 0x29)
	{
		// Keen6 conveyor belt right
		ck_nextX = tics * 8;
		ck_nextY = 0;
		obj->user1 = 0;
		CK_PhysUpdateNormalObj(obj);
	}
	else if (obj->topTI == 0x31)
	{
		// Keen6 conveyor belt left
		ck_nextX = tics * -8;
		ck_nextY = 0;
		obj->user1 = 0;
		CK_PhysUpdateNormalObj(obj);
	}

	if ((obj->rightTI && obj->xDirection == -1) || (obj->leftTI && obj->xDirection == 1))
	{
		obj->timeUntillThink = 0;
		obj->currentAction = &CK_ACT_keenStanding;
		obj->gfxChunk = (obj->xDirection == -1) ? obj->currentAction->chunkLeft : obj->currentAction->chunkRight;
	}

	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
}

void CK_KeenReadThink(CK_object *obj)
{
	if (ck_inputFrame.xaxis != 0 || ck_keenState.jumpIsPressed || ck_keenState.pogoIsPressed)
	{
		obj->currentAction = &CK_ACT_keenStowBook1;
		obj->user1 = obj->user2 = 0;
	}
}

void CK_KeenJumpThink(CK_object *obj)
{
	// Handle Jump Cheat
	if (ck_gameState.jumpCheat && ck_keenState.jumpIsPressed)
	{
		obj->velY = -40;
		ck_keenState.jumpTimer = 18;
		ck_keenState.jumpWasPressed = true;
	}	 

	if (ck_keenState.jumpTimer)
	{
		if (ck_keenState.jumpTimer <= tics)
		{
			ck_nextY = obj->velY * ck_keenState.jumpTimer;
			ck_keenState.jumpTimer = 0;
		}
		else
		{
			ck_nextY = obj->velY * tics;
			if (!ck_gameState.jumpCheat)
			{
				ck_keenState.jumpTimer -= tics;
			}
		}

		// Stop moving up if we've let go of control.
		if (!ck_keenState.jumpIsPressed)
		{
			ck_keenState.jumpTimer = 0;
		}

		if (!ck_keenState.jumpTimer && obj->currentAction->next)
		{
			obj->currentAction = obj->currentAction->next;
		}
	}
	else
	{
		//TODO: Check this w/ K5Disasm and/or x-disasm
		if (ck_gameState.difficulty == D_Easy)
		{
			CK_PhysGravityMid(obj);
		}
		else	// Normal or Hard
		{
			CK_PhysGravityHigh(obj);
		}

		if (obj->velY > 0 && obj->currentAction != &CK_ACT_keenFall1 && obj->currentAction != &CK_ACT_keenFall2)
		{
			obj->currentAction = obj->currentAction->next;
		}
	}


	//Move horizontally
	if (ck_inputFrame.xaxis)
	{

		obj->xDirection = ck_inputFrame.xaxis;
		CK_PhysAccelHorz(obj, ck_inputFrame.xaxis*2, 24);
	}
	else CK_PhysDampHorz(obj);

	//Pole
	if (obj->bottomTI == 17)
	{
		ck_nextX = 0;
		obj->velX = 0;
	}

	//Shooting
	if (ck_keenState.shootIsPressed && !ck_keenState.shootWasPressed)
	{
		ck_keenState.shootWasPressed = true;
		switch (ck_inputFrame.yaxis)
		{
		case -1:
			obj->currentAction = &CK_ACT_keenJumpShootUp1;
			break;
		case 0:
			obj->currentAction = &CK_ACT_keenJumpShoot1;
			break;
		case 1:
			obj->currentAction = &CK_ACT_keenJumpShootDown1;
			break;
		}
		return;
	}

	if (ck_keenState.pogoIsPressed && !ck_keenState.pogoWasPressed)
	{
		ck_keenState.pogoWasPressed = true;
		obj->currentAction = &CK_ACT_keenPogo2;
		ck_keenState.jumpTimer = 0;
		return;
	}

	if (ck_inputFrame.yaxis == -1)
	{
		CK_KeenTryClimbPole(obj);
	}
	
}

void CK_KeenJumpDrawFunc(CK_object *obj)
{
	if (obj->rightTI && obj->xDirection == -1)
	{
		obj->velX = 0;
	}
	else if (obj->leftTI && obj->xDirection == 1)
	{
		obj->velX = 0;
	}

	// Did we hit our head on the ceiling?
	if (obj->bottomTI)
	{
		//TODO: Something to do with poles (push keen into the centre)
		if (obj->bottomTI == 17)	//Pole
		{
			obj->posY -= 32;
			obj->clipRects.unitY1 -= 32;
			obj->velX = 0;
			obj->posX = (obj->clipRects.tileXmid << 8) - 32;
		}
		else if (!ck_gameState.jumpCheat)
		{
			SD_PlaySound(KEENHITCEILINGSND);
			if (obj->bottomTI > 1)
			{
				obj->velY += 16;
				if (obj->velY < 0)
					obj->velY = 0;
			}
			else
			{
				obj->velY = 0;
			}
			ck_keenState.jumpTimer = 0;
		}
	}

	// Have we landed?
	if (obj->topTI)
	{
		obj->deltaPosY = 0;
		//Check if deadly.
		if ((obj->topTI & ~7) == 8)
		{
			CK_KillKeen();
		}
		else
		{
#ifdef KEEN5
			if (obj->topTI == 0x39) // Fuse
			{
				SD_PlaySound(KEENLANDONFUSESND);
			}
#endif
			if (obj->topTI != 0x19 || !ck_keenState.jumpTimer) // Or standing on a platform.
			{
				obj->user1 = obj->user2 = 0;	// Being on the ground is boring.
	
				//TODO: Finish these
				if (obj->currentAction == &CK_ACT_keenJumpShoot1)
				{
					CK_SetAction2(obj, &CK_ACT_keenShoot1);
				}
				else if (obj->currentAction == &CK_ACT_keenJumpShootUp1)
				{
					CK_SetAction2(obj, &CK_ACT_keenShootUp1);
				}	
				else if (ck_inputFrame.xaxis)
				{
					CK_SetAction2(obj, &CK_ACT_keenRun1);
				}
				else
				{
					CK_SetAction2(obj, &CK_ACT_keenStanding);
				}
				SD_PlaySound(KEENLANDSND);
			}
		}
	}
	else if (obj->deltaPosY > 0)
	{
		// temp6 = Keen's previous upper y coord
		unsigned temp6 = obj->clipRects.unitY1 - obj->deltaPosY;
		// temp8 = Keen's current upper y coord - 1.5 tiles, rounded to nearest tile, + 1.5 tiles
		unsigned temp8 = ((obj->clipRects.unitY1 - 64) & 0xFF00) + 64;
		// temp10 = temp8 in tile coords, - 1
		unsigned temp10 = (temp8 >> 8) - 1 ;

		// If we're moving past a tile boundary.
		if (temp6 < temp8 && obj->clipRects.unitY1 >= temp8)
		{
			// Moving left...
			if (ck_inputFrame.xaxis == -1)
			{
				int tileX = obj->clipRects.tileX1 - ((obj->rightTI)?1:0);
				int tileY = temp10;
				//VL_ScreenRect((tileX << 4) - (originxglobal >> 4), (tileY << 4) - (originyglobal >> 4), 16, 16, 1);
				int upperTile = CA_TileAtPos(tileX, tileY, 1);
				int lowerTile = CA_TileAtPos(tileX, tileY+1, 1);
				if ( (!TI_ForeLeft(upperTile) && !TI_ForeRight(upperTile) && !TI_ForeTop(upperTile) && !TI_ForeBottom(upperTile)) &
					TI_ForeRight(lowerTile) && TI_ForeTop(lowerTile))
				{
					obj->xDirection = -1;
					obj->clipped = CLIP_not;
					obj->posX = (obj->posX & 0xFF00) + 128;
					obj->posY = (temp8 - 64);
					obj->velY = obj->deltaPosY = 0;
					CK_SetAction2(obj, &CK_ACT_keenHang1);
				}
			}
			else if (ck_inputFrame.xaxis == 1)
			{
				int tileX = obj->clipRects.tileX2 + ((obj->leftTI)?1:0);
				int tileY = temp10;
				int upperTile = CA_TileAtPos(tileX, tileY, 1);
				int lowerTile = CA_TileAtPos(tileX, tileY+1, 1);

				if (!TI_ForeLeft(upperTile) && !TI_ForeRight(upperTile) && !TI_ForeTop(upperTile) && !TI_ForeBottom(upperTile) &
					TI_ForeLeft(lowerTile) && TI_ForeTop(lowerTile))
				{
					obj->xDirection = 1;
					obj->clipped = CLIP_not;
					obj->posX = (obj->posX & 0xFF00) + 256;
					obj->posY = (temp8 - 64);
					obj->velY = obj->deltaPosY = 0;
					CK_SetAction2(obj, &CK_ACT_keenHang1);
				}
			}
		}
	}

	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
}

void CK_KeenPogoBounceThink(CK_object *obj)
{
	obj->velY = -48;
	ck_nextY = 6 * obj->velY;
	ck_keenState.jumpTimer = 24;
	SD_PlaySound(KEENPOGOSND);
}

void CK_KeenPogoThink(CK_object *obj)
{
	if (!ck_keenState.jumpTimer)
	{
		if (ck_gameState.difficulty == D_Easy)
		{
			CK_PhysGravityMid(obj);
		}
		else
		{
			CK_PhysGravityHigh(obj);
		}
	}
	else
	{
		if (ck_keenState.jumpIsPressed || ck_keenState.jumpTimer <= 9) CK_PhysGravityLow(obj);
		else CK_PhysGravityHigh(obj);

		if (ck_keenState.jumpTimer <= tics) ck_keenState.jumpTimer = 0;
		else ck_keenState.jumpTimer -= tics;

		if (!ck_keenState.jumpTimer && obj->currentAction->next) obj->currentAction = obj->currentAction->next;
	}
	if (ck_inputFrame.xaxis)
	{
		if (!obj->velX)
			obj->xDirection = ck_inputFrame.xaxis;
		CK_PhysAccelHorz(obj, ck_inputFrame.xaxis, 24);
	}
	else
	{
		ck_nextX += obj->velX * tics;
		if (obj->velX < 0) obj->xDirection = -1;
		else if (obj->velX > 0) obj->xDirection = 1;
	}

	// Stop for poles?
	if (obj->bottomTI == 17)
	{
		ck_nextX = 0;
		obj->velX = 0;
	}

	//Shooting
	if (ck_keenState.shootIsPressed && !ck_keenState.shootWasPressed)
	{
		ck_keenState.shootWasPressed = true;
		switch (ck_inputFrame.yaxis)
		{
		case -1:
			obj->currentAction = &CK_ACT_keenJumpShootUp1;
			return;
		case 0:
			obj->currentAction = &CK_ACT_keenJumpShoot1;
			return;
		case 1:
			obj->currentAction = &CK_ACT_keenJumpShootDown1;
			return;
		}
	}
	
	//Stop pogoing if Alt pressed
	if (ck_keenState.pogoIsPressed && !ck_keenState.pogoWasPressed)
	{
		ck_keenState.pogoWasPressed = true;
		obj->currentAction = &CK_ACT_keenFall1;
	}
}

void CK_KeenBreakFuse(int x, int y)
{
#if 0
	unsigned brokenFuseTiles[] = {0, 0};

	CK5_SpawnFuseExplosion(x,y);
	if (!(--ck_gameState.fusesRemaining))
	{
		CK5_SpawnLevelEnd();
	}

	
	brokenFuseTiles[0] = CA_TileAtPos(0,0,1);
	brokenFuseTiles[1] = CA_TileAtPos(0,1,1);

	RF_MemToMap(brokenFuseTiles, 1, x, y, 1, 2);
#endif
}

void CK_KeenPogoDrawFunc(CK_object *obj)
{
	if (obj->rightTI && obj->xDirection == -1)
	{
		obj->velX = 0;
	}
	else if (obj->leftTI && obj->xDirection == 1)
	{
		obj->velX = 0;
	}

	if (obj->bottomTI)
	{
		
		if (obj->bottomTI == 17)	//Pole
		{
			obj->posY -= 32;
			obj->clipRects.unitY1 -= 32;
			obj->velX = 0;
			obj->posX = (obj->clipRects.tileXmid << 8) - 32;
		}
		else if (!ck_gameState.jumpCheat)
		{
			SD_PlaySound(KEENHITCEILINGSND);

			if (obj->bottomTI > 1)
			{
				obj->velY += 16;
				if (obj->velY < 0) obj->velY = 0;
			}
			else obj->velY = 0;
		
			ck_keenState.jumpTimer = 0;
		}
	}

	// Houston, we've landed!
	if (obj->topTI)
	{
		obj->deltaPosY = 0;
		//Check if deadly.
		if ((obj->topTI & ~7) == 8)
		{
			CK_KillKeen();
		}
		else
		{
			if (obj->topTI == 0x39) // Fuse
			{
				if (obj->velY >= 0x30)
				{
					CK_KeenBreakFuse(obj->clipRects.tileXmid, obj->clipRects.tileY2);
					RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
					return;
				}
#ifdef KEEN5
				SD_PlaySound(KEENLANDONFUSESND);
#endif
			}
			if (obj->topTI != 0x19 || ck_keenState.jumpTimer == 0)
			{
				obj->velY = -48;
				ck_keenState.jumpTimer = 24;
				SD_PlaySound(KEENPOGOSND);
				CK_SetAction2(obj, &CK_ACT_keenPogo2);
			}
		}
	}

	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
}

void CK_KeenSpecialColFunc(CK_object *obj, CK_object *other)
{
	if (other->type == CT_Platform)
	{
		obj->clipped = CLIP_normal;
		CK_SetAction2(obj, &CK_ACT_keenFall1);
		ck_keenState.jumpTimer = 0;
		obj->velX = 0;
		obj->velY = 0;
		CK_PhysPushY(obj,other);
		return;
	}
#if 0
	else if (other->type == CT_Ampton || other->type == CT_Korath)
	{
		obj->zLayer = 1;
		obj->clipped = CLIP_normal;
		CK_SetAction2(obj, &CK_ACT_keenFall1);
		ck_keenState.jumpTimer = 0;
		obj->velX = 0;
		obj->velY = 0;
		return;
	}
#endif

}

void CK_KeenSpecialDrawFunc(CK_object *obj)
{
	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
}

void CK_KeenHangThink(CK_object *obj)
{
	if (ck_inputFrame.yaxis == -1 || ck_inputFrame.xaxis == obj->xDirection)
	{
		obj->currentAction = &CK_ACT_keenPull1;

		if(obj->xDirection == 1)
		{
			ck_nextY = -256;
		}
		else
		{
			ck_nextY = -128;
		}
		//TODO: Set keen->zlayer 3

		//if (obj->xDirection == 1)
		//{
			

	}
	else if (ck_inputFrame.yaxis == 1 || (ck_inputFrame.xaxis && ck_inputFrame.xaxis != obj->xDirection))
	{
		// Drop down.
		obj->currentAction = &CK_ACT_keenFall1;
		obj->clipped = CLIP_normal;
	}
}

void CK_KeenPullThink1(CK_object *obj)
{
	if (obj->xDirection == 1)
		ck_nextX = 128;
	else
		ck_nextY = -128;
}

void CK_KeenPullThink2(CK_object *obj)
{
	ck_nextX = obj->xDirection * 128;
	ck_nextY = -128;
}

void CK_KeenPullThink3(CK_object *obj)
{
	ck_nextY = -128;
}

void CK_KeenPullThink4(CK_object *obj)
{
	obj->clipped = CLIP_normal;
	obj->zLayer = 1;
	ck_nextY = 128;
}


void CK_KeenDeathThink(CK_object *obj)
{
	CK_PhysGravityMid(obj);
	ck_nextX = obj->velX * tics;
	if (!CK_ObjectVisible(obj))
	{
		ck_levelState = 1;
	}
}

void CK_KillKeen()
{
	CK_object *obj = ck_keenObj;
	if (ck_invincibilityTimer)
	{
		return;
	}

	if (ck_godMode)
	{
		return;
	}

	//TODO: ACTION_KEENNOT, KeenMoon
	ck_invincibilityTimer = 30;
	ck_scrollDisabled = true;
	obj->clipped = CLIP_not;
	obj->zLayer = 3;
	if (US_RndT() < 0x80)
	{
		CK_SetAction2(obj, &CK_ACT_keenDie0);
	}
	else
	{
		CK_SetAction2(obj, &CK_ACT_keenDie1);
	}

	SD_PlaySound(KEENDIESND);

	obj->velY = -40;
	obj->velX = 16;
}

void CK_KeenPoleHandleInput(CK_object *obj)
{
	if (ck_inputFrame.xaxis)
		obj->xDirection = ck_inputFrame.xaxis;

	//Shooting things. *ZAP!*
	if (ck_keenState.shootIsPressed && !ck_keenState.shootWasPressed)
	{
		ck_keenState.shootWasPressed = true;

		switch (ck_inputFrame.yaxis)
		{
		case -1:
			obj->currentAction = &CK_ACT_keenPoleShootUp1;
			break;
		case 0:
			obj->currentAction = &CK_ACT_keenPoleShoot1;
			break;
		case 1:
			obj->currentAction = &CK_ACT_keenPoleShootDown1;
			break;
		}
	}

	
	if (ck_keenState.jumpIsPressed && !ck_keenState.jumpWasPressed)
	{
		ck_keenState.jumpWasPressed = true;
		SD_PlaySound(KEENJUMPSND);
		obj->velX = ck_KeenPoleOffs[ck_inputFrame.xaxis+1];
		obj->velY = -20;
		obj->clipped = CLIP_normal;
		ck_keenState.jumpTimer = 10;
		obj->currentAction = &CK_ACT_keenJump1;
		obj->yDirection = 1;
		ck_keenState.poleGrabTime = lasttimecount;
	}
	return;
}

void CK_KeenPoleSitThink(CK_object *obj)
{
	int groundTile;

	//TODO: Support climb up/down
	if (ck_inputFrame.yaxis == 1)
	{
		obj->currentAction = &CK_ACT_keenPoleDown1;
		obj->yDirection = 1;
		CK_KeenPoleDownThink(obj);
		return;
	}
	else if (ck_inputFrame.yaxis == -1)
	{
		obj->currentAction = &CK_ACT_keenPoleUp1;
		obj->yDirection = -1;
		//CK_KeenPoleUpThink(obj);
		return;
	}

	// When keen is at ground level, allow dismounting using left/right.
	if (ck_inputFrame.xaxis)
	{
		groundTile = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY2+1, 1);
		if (TI_ForeTop(groundTile))
		{
			obj->velX = 0;
			obj->velY = 0;
			obj->clipped = CLIP_normal;
			ck_keenState.jumpTimer = 0;
			obj->currentAction = &CK_ACT_keenFall1;
			obj->yDirection = 1;
			SD_PlaySound(KEENFALLSND);
			return;
		}
	}

	//TODO: Pole input func
	CK_KeenPoleHandleInput(obj);
}

void CK_KeenPoleUpThink(CK_object *obj)
{
	int topTile = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY1, 1);
	
	if ((TI_ForeMisc(topTile) & 127) != 1)
	{
		ck_nextY = 0;
		obj->currentAction = &CK_ACT_keenPoleSit;
		CK_KeenPoleHandleInput(obj);
		return;
	}

	if (ck_inputFrame.yaxis == 0)
	{
		obj->currentAction = &CK_ACT_keenPoleSit;
		obj->yDirection = 0;
		//CK_KeenPoleSitThink(obj);
	}
	else if (ck_inputFrame.yaxis == 1)
	{
		obj->currentAction = &CK_ACT_keenPoleDown1;
		obj->yDirection = 1;
		CK_KeenPoleDownThink(obj);
	}

	CK_KeenPoleHandleInput(obj);
}

void CK_KeenPoleDownThink(CK_object *obj)
{

	int tileUnderneath = CA_TileAtPos(obj->clipRects.tileXmid, (obj->clipRects.unitY2-64) >> 8, 1);

	if ((TI_ForeMisc(tileUnderneath) & 127) != 1)
	{
		// We're no longer on a pole.
		SD_PlaySound(KEENFALLSND);
		obj->currentAction = &CK_ACT_keenFall1;
		ck_keenState.jumpTimer = 0;
		obj->velX = ck_KeenPoleOffs[ck_inputFrame.xaxis + 1];
		obj->velY = 0;
		obj->clipped = CLIP_normal;
		obj->clipRects.tileY2 -= 1;	//WTF?
		return;
	}

	if (ck_inputFrame.yaxis == 0)
	{
		obj->currentAction = &CK_ACT_keenPoleSit;
		obj->yDirection = 0;
	}
	else if (ck_inputFrame.yaxis == -1)
	{
		obj->currentAction = &CK_ACT_keenPoleUp1;
		obj->yDirection = -1;
	}
	
	CK_KeenPoleHandleInput(obj);
}

void CK_KeenPoleDownDrawFunc(CK_object *obj)
{
	// Check if keen is trying to climb through the floor.
	// It's quite a strange clipping error if he succeeds.

	int groundTile = CA_TileAtPos(obj->clipRects.tileXmid, obj->clipRects.tileY2, 1);

	if (TI_ForeTop(groundTile) == 1)
	{
		int yReset = -(obj->clipRects.unitY2 & 255) - 1;
		obj->posY += yReset;
		obj->clipRects.unitY2 += yReset;
		obj->clipRects.tileY2 += -1;
		obj->clipped = CLIP_normal;
		CK_SetAction2(obj, &CK_ACT_keenLookDown1);
	}

	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
}

// Shooting

void CK_SpawnShot(int x, int y, int direction)
{
	CK_object *shot;

	if (!ck_gameState.numShots)
	{
		SD_PlaySound(KEENOUTOFAMMOSND);
		return;
	}

	ck_gameState.numShots--;

	shot = CK_GetNewObj(true);
	shot->posX = x;
	shot->posY = y;
	shot->zLayer = 0;
	shot->type = CT_Stunner; // TODO: obj_stunner
	shot->active = OBJ_ALWAYS_ACTIVE;

	SD_PlaySound(KEENSHOOTSND);
	
	switch(direction)
	{
	case 0:
		shot->xDirection = 0;
		shot->yDirection = -1;
		break;
	case 2:
		shot->xDirection = 1;
		shot->yDirection = 0;
		break;
	case 4:
		shot->xDirection = 0;
		shot->yDirection = 1;
		break;
	case 6:
		shot->xDirection = -1;
		shot->yDirection = 0;
		break;
	default:
		Quit("SpawnShot: Bad dir!");
	}

	CK_SetAction(shot, &CK_ACT_keenShot1);
}

void CK_ShotHit(CK_object *obj)
{
	//TODO: Implement obj_ classes.
	obj->type = CT_Friendly;
	CK_SetAction2(obj, &CK_ACT_keenShotHit1);
	SD_PlaySound(KEENSHOTHITSND);
}

void CK_ShotThink(CK_object *shot)
{
	CK_object *currentObj;

	// Stun things which are offscreen.
	if ((shot->clipRects.tileX2 < (originxglobal >> 8)) ||
	    (shot->clipRects.tileY2 < (originyglobal >> 8)) ||
	    (shot->clipRects.tileX1 > (originxglobal >> 8) + (320 >> 4)) ||
	    (shot->clipRects.tileY1 > (originyglobal >> 8) + (208 >> 4)))
	{
		if ((shot->clipRects.tileX2 + 10 < (originxglobal >> 8)) ||
		    (shot->clipRects.tileX1 - 10 > (originxglobal >> 8) + (320 >> 4)) ||
		    (shot->clipRects.tileY2 + 6 < (originyglobal >> 8)) ||
		    (shot->clipRects.tileY1 - 6 > (originyglobal >> 8) + (208 >> 4)))
		{
			CK_RemoveObj(shot);
			return;
		}
		for (currentObj = ck_keenObj->next; currentObj; currentObj = currentObj->next)
		{
			if (currentObj->active ||
			    (shot->clipRects.unitX2 <= currentObj->clipRects.unitX1) ||
			    (shot->clipRects.unitX1 >= currentObj->clipRects.unitX2) ||
			    (shot->clipRects.unitY1 >= currentObj->clipRects.unitY2) ||
			    (shot->clipRects.unitY2 <= currentObj->clipRects.unitY1))
				continue;
			if (currentObj->currentAction->collide)
			{
				currentObj->currentAction->collide(currentObj, shot);
				currentObj->visible = true;
				currentObj->active = OBJ_ACTIVE;
			}
			if (shot->type == CT_nothing)
				return;
		}
	}
}

void CK_ShotDrawFunc(CK_object *obj)
{
	unsigned t;

	// shoot down through a pole hole
	if (obj->topTI == 1 && obj->clipRects.tileX1 != obj->clipRects.tileX2) 
	{
		t = CA_TileAtPos(obj->clipRects.tileX2, obj->clipRects.tileY1-1, 1);
		if (TI_ForeTop(t) == 0x11) 
		{
			obj->topTI = 0x11;
			obj->posX += 0x100 - (obj->posX & 0xFF);
		}
	} 
	// move into pole hole before making contact
	else if (obj->topTI == 0x11 && obj->clipRects.tileX1 != obj->clipRects.tileX2) 
	{
		obj->posX &= 0xFF00;
	}

	// shoot through pole hole upwards
	if (obj->bottomTI == 1 && obj->clipRects.tileX1 != obj->clipRects.tileX2) 
	{
		t = CA_TileAtPos(obj->clipRects.tileX2, obj->clipRects.tileY2+1, 1);
		if (TI_ForeBottom(t) == 0x11) 
		{
			obj->bottomTI = 0x11;
			obj->posX += 0x100 - (obj->posX & 0xFF);
		}
	} 
	// move into pole hole whilst travelling upwards
	else if (obj->bottomTI == 0x11 && obj->clipRects.tileX1 != obj->clipRects.tileX2) 
	{
		obj->posX &= 0xFF00;
	}

	// if hit any other type of object, die
	if (obj->topTI != 0x11 && obj->bottomTI != 0x11) 
	{
		if (obj->topTI || obj->bottomTI || obj->rightTI || obj->leftTI) 
		{
			CK_ShotHit(obj);
		}
	} 
	else 
	// correct for pole hole passage
	{
		ck_nextY = obj->currentAction->velY * tics * obj->yDirection;
		obj->posY += ck_nextY;
		obj->clipRects.unitY1 += ck_nextY;
		obj->clipRects.unitY2 += ck_nextY;
		obj->clipRects.tileY1 = obj->clipRects.unitY1 >> 8;
		obj->clipRects.tileY2 = obj->clipRects.unitY2 >> 8;
	}
	RF_PlaceSprite(&obj->sde, obj->posX, obj->posY, obj->gfxChunk, 0, obj->zLayer);
}

void CK_KeenSpawnShot(CK_object *obj)
{
	if (obj->currentAction == &CK_ACT_keenShoot1)
	{
		if (obj->xDirection == 1)
		{
			CK_SpawnShot(obj->posX + 256, obj->posY + 64, 2);
		}
		else
		{
			CK_SpawnShot(obj->posX - 128, obj->posY + 64, 6);
		}
	}
	if (obj->currentAction == &CK_ACT_keenJumpShoot2)
	{
		if (obj->xDirection == 1)
		{
			CK_SpawnShot(obj->posX + 256, obj->posY + 32, 2);
		}
		else
		{
			CK_SpawnShot(obj->posX, obj->posY + 32, 6);
		}
	}
	if (obj->currentAction == &CK_ACT_keenJumpShootDown2)
	{
		CK_SpawnShot(obj->posX + 128, obj->posY + 288, 4);
	}
	if (obj->currentAction == &CK_ACT_keenJumpShootUp2)
	{
		CK_SpawnShot(obj->posX + 80, obj->posY - 160, 0);
	}
	if (obj->currentAction == &CK_ACT_keenShootUp1)
	{
		CK_SpawnShot(obj->posX + 80, obj->posY - 160, 0);
	}
	if (obj->currentAction == &CK_ACT_keenPoleShoot1)
	{
		if (obj->xDirection == 1)
		{
			CK_SpawnShot(obj->posX + 256, obj->posY + 64, 2);
		}
		else
		{
			CK_SpawnShot(obj->posX - 128, obj->posY + 64, 6);
		}
	}
	if (obj->currentAction == &CK_ACT_keenPoleShootUp1)
	{
		if (obj->xDirection == 1)
		{
			CK_SpawnShot(obj->posX + 96, obj->posY + 64, 0);
		}
		else
		{
			CK_SpawnShot(obj->posX + 192, obj->posY + 64, 0);
		}
	}
	if (obj->currentAction == &CK_ACT_keenPoleShootDown1)
	{
		if (obj->xDirection == 1)
		{
			CK_SpawnShot(obj->posX + 96, obj->posY + 384, 4);
		}
		else
		{
			CK_SpawnShot(obj->posX + 192, obj->posY + 384, 4);
		}
	}
}

void CK_KeenFall(CK_object *obj)
{
	CK_PhysGravityHigh(obj);
	ck_nextX = obj->velX * tics;
}

void AR_KeenVines(CK_object *obj)
{
	ck_levelState = LS_Vines;
}
