/* Keen Dreams Source Code
 * Copyright (C) 2014 Javier M. Chavez
 * Copyright (C) 1993-2014 Flat Rock Software
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// KD_MISC.C

#include "KD_DEF.H"
#pragma	hdrstop

/*
=============================================================================

LOCAL CONSTANTS

=============================================================================
*/


/*
=============================================================================

GLOBAL VARIABLES

=============================================================================
*/

CK_action CK_ACT_DoorOpen1 = {0, 0, AT_UnscaledOnce, 0, 0, 10, 0, 0, CK_DoorOpen, NULL, NULL, &CK_ACT_DoorOpen2};
CK_action CK_ACT_DoorOpen2 = {0, 0, AT_UnscaledOnce, 0, 0, 10, 0, 0, CK_DoorOpen, NULL, NULL, &CK_ACT_DoorOpen3};
CK_action CK_ACT_DoorOpen3 = {0, 0, AT_UnscaledOnce, 0, 0, 10, 0, 0, CK_DoorOpen, NULL, NULL, NULL};

/*
=============================================================================

LOCAL VARIABLES

=============================================================================
*/


// This file contains some object functions (think, etc) which are common to
// several episodes.

void CK_DoorOpen(CK_object *obj)
{
	int i;
	unsigned tilesToReplace[0x30];

	if (obj->user1 + 2 > 0x30)
	{
		Quit("Door too tall!");
	}

	for (i = 0; i < obj->user1 + 2; ++i)
	{
		tilesToReplace[i] = CA_TileAtPos(obj->posX, obj->posY+i, 1) + 1;
	}

	RF_MemToMap(tilesToReplace, 1, obj->posX, obj->posY, 1, obj->user1 + 2);
}

void CK_SecurityDoorOpen(CK_object *obj)
{
	int x, y;
	unsigned tilesToReplace[0x30];
	for (y = 0; y < 4; ++y)
	{
		for (x = 0; x < 4; ++x)
		{
			tilesToReplace[y*4+x] = CA_TileAtPos(obj->posX+x, obj->posY+y, 1) - 4;
		}
	}

	RF_MemToMap(tilesToReplace, 1, obj->posX, obj->posY, 4, 4);
	obj->user1++;
	if (obj->user1 == 3)
	{
		obj->currentAction = 0;
	}
}
